print "  \n**********CVhaplot2.0**********\n";
print     "*    Coded by Zu-Shi Huang    *\n";
print     "*    Institute of Zoology     *\n";
print     "* Chinese Academy of Sciences *\n";
print     "*     huangzs\@ioz.ac.cn       *\n";
print     "*******************************\n";

$genofile=$ARGV[0];
if(!$genofile){
    print "Please input the name of the genotype data file:";
    $genofile=<stdin>;
}
open (GENO, $genofile);
@genotypedata=<GENO>;
$linegenotypedata=(@genotypedata);
close GENO;
if(!$linegenotypedata){
    print "Can not find the genotype data file!!!\n";
    print "\nPlease type the correct name of the genotype data file in the command line or confirm that the genotype data file and the script CV.pl are located in the same folder!!!";
    exit;
}
use Cwd;
$homedirectory=cwd;
print "\nHave you saved the outputfiles of various programs into a new folder to control which solution of an algorithm is used in the CV analysis?(y/n):";
$directoryjudge=<stdin>;
chomp($directoryjudge);
if(($directoryjudge ne 'n') && ($directoryjudge ne 'y')){
   print "\nPlease make a correct choice(y/n):";
   $directoryjudge=<stdin>;
   chomp($directoryjudge);
}
if($directoryjudge eq 'n'){
   mkdir "consensusvote", 0775;
   chdir "consensusvote" or die "cannot chdir to consensusvote:$!";
   $CVfile="CV.txt";
   $solutionfile="softwaresolutions.txt";
   $cvsolutionfile="CVsolution.txt";
   opendir (PHASE1, "$homedirectory/softwareresults/phase");
   @PHASEfiles=grep(!/^\.\.?$/,readdir PHASE1);
   @PHASEfiles=sort(@PHASEfiles);
   closedir(PHASE1);
   opendir (ARLEQUINEM1, "$homedirectory/softwareresults/arlequin");
   @Arlequinfiles=grep(!/^\.\.?$/,readdir ARLEQUINEM1);
   @Arlequinfiles=sort(@Arlequinfiles);
   closedir(ARLEQUINEM1);
   opendir (HAPLOREC1, "$homedirectory/softwareresults/haplorec");
   @Haplorecfiles=grep(!/^\.\.?$/,readdir HAPLOREC1);
   @Haplorecfiles=sort(@Haplorecfiles);
   closedir(HAPLOREC1);
   opendir (HAPLOTYPER1, "$homedirectory/softwareresults/haplotyper");
   @Haplotyperfiles=grep(!/^\.\.?$/,readdir HAPLOTYPER1);
   @Haplotyperfiles=sort(@Haplotyperfiles);
   closedir(HAPLOTYPER1);
   opendir (GCHAP1, "$homedirectory/softwareresults/gchap");
   @GCHAPfiles=grep(!/^\.\.?$/,readdir GCHAP1);
   @GCHAPfiles=sort(@GCHAPfiles);
   closedir(GCHAP1);
   print "\nDo you want to include the solution of GERBIL in the consensus vote analysis?(y/n):";
   $gerbiljudge=<stdin>;
   chomp($gerbiljudge);
   if(($gerbiljudge ne 'n') && ($gerbiljudge ne 'y')){
      print "\nPlease make a correct choice(y/n):";
      $gerbiljudge=<stdin>;
      chomp($gerbiljudge);
   }
   if($gerbiljudge eq 'y'){
      $gerbilname=0;
      opendir (GERBIL1, "$homedirectory/softwareresults/gerbil");
      @Gerbilfiles=grep(!/^\.\.?$/,readdir GERBIL1);
      closedir(GERBIL1);
      $geibilfilenumber=(@Gerbilfiles);
      for($i=0;$i<$geibilfilenumber;$i++){
         if($Gerbilfiles[$i]=~/.01/){
            $gerbilname=$Gerbilfiles[$i];
            last;
         }
      }
   }
   $hapinferxcvname=0;
   opendir (HAPINFERXCV1, "$homedirectory/consistencyresult");
   @Hapinferxcvfiles=grep(!/^\.\.?$/,readdir HAPINFERXCV1);
   @Hapinferxcvfiles=sort(@Hapinferxcvfiles);
   closedir(HAPINFERXCV1);
   $hapinferxcvnumber=(@Hapinferxcvfiles);
   for($i=0;$i<$hapinferxcvnumber;$i++){
        if($Hapinferxcvfiles[$i]=~/hapinfCV.txt/){
                $hapinferxcvname=$Hapinferxcvfiles[$i];
                last;
        }
   }
   $PHASEinfile="$homedirectory/softwareresults/phase/$PHASEfiles[0]";
   $PHASEpairs="$homedirectory/softwareresults/phase/$PHASEfiles[1]";
   $ArlequinEMfile="$homedirectory/softwareresults/arlequin/$Arlequinfiles[0]";
   $HaploRecfile="$homedirectory/softwareresults/haplorec/$Haplorecfiles[0]";
   $HAPLOTYPERfile="$homedirectory/softwareresults/haplotyper/$Haplotyperfiles[0]";
   $GCHapfile="$homedirectory/softwareresults/gchap/gchapoutput";
   $HAPINFERXCVfile="$homedirectory/consistencyresult/hapinfCV.txt";
   $GERBILFILE="$homedirectory/softwareresults/gerbil/gerbiloutput.01";
   $CHARACTERfile="$homedirectory/transfile/character.txt";
   @files=();
   @files1=();
   $filenumber=0;
   $CValgorithms=0;
   if($Arlequinfiles[0]){
        $files1[$filenumber]=$Arlequinfiles[0];
        $files[$filenumber]="ARLEQUINEM";
        $filenumber++;
        $CValgorithms++;
   }
   if($Haplorecfiles[0]){
        $files1[$filenumber]=$Haplorecfiles[0];
        $files[$filenumber]="HAPLOREC";
        $filenumber++;
        $CValgorithms++;
   }
   if($Haplotyperfiles[0]){
        $files1[$filenumber]=$Haplotyperfiles[0];
        $files[$filenumber]="HAPLOTYPER";
        $filenumber++;
        $CValgorithms++;
   }
   if($GCHAPfiles[0]){
        $files1[$filenumber]=$GCHAPfiles[0];
        $files[$filenumber]="GCHap";
        $filenumber++;
        $CValgorithms++;
   }
   if($hapinferxcvname){
        $files1[$filenumber]=$hapinferxcvname;
        $files[$filenumber]="HAPINFCV";
        $jugdehapinferx=1;
        $filenumber++;
        $CValgorithms++;
   }
   if($gerbilname){
        $files1[$filenumber]=$gerbilname;
        $files[$filenumber]="GERBIL";
        $filenumber++;
        $CValgorithms++;
   }
   if($PHASEfiles[0]){
        $files1[$filenumber]=$PHASEfiles[0];
        $files[$filenumber]="PHASE";
        $filenumber++;
        $files1[$filenumber]=$PHASEfiles[1];
        $jugdephse=1;
        $filenumber++;
        $CValgorithms++;
   }
}
if($directoryjudge eq 'y'){
   print "\nPlease tell me the name of your folder:";
   $creatfile=<stdin>;
   chomp($creatfile);
   chdir ($creatfile) or die "cannot chdir to $creatfile:$!";
   opendir (CONSENSUSVOTE, "$homedirectory/$creatfile");
   @files=grep(!/^\.\.?$/,readdir CONSENSUSVOTE);
   closedir(CONSENSUSVOTE);
   $filenumber=(@files);
   $CValgorithms=0;
   for($i=0;$i<$filenumber;$i++){
        if($files[$i]=~/pairs/){
                $PHASEpairs=$files[$i];
                $files[$i]=();
        }
        if($files[$i]=~/character/){
                $CHARACTERfile=$files[$i];
                $files[$i]=();
        }
   }
   for($i=0;$i<$filenumber;$i++){
        if($files[$i]=~/phase/){
                $PHASEinfile=$files[$i];
                $files[$i]="PHASE";
                $jugdephse=1;
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/hapinferx/){
                $HAPINFERXfile=$files[$i];
                $files[$i]="HAPINFERX";
                $jugdehapinferx=1;
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/Arlequin/){
                $ArlequinEMfile=$files[$i];
                $files[$i]="ARLEQUINEM";
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/HaploRec/){
                $HaploRecfile=$files[$i];
                $files[$i]="HAPLOREC";
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/haplotyper/){
                $HAPLOTYPERfile=$files[$i];
                $files[$i]="HAPLOTYPER";
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/gchap/){
                $GCHapfile=$files[$i];
                $files[$i]="GCHap";
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/gerbil/){
                $GERBILFILE=$files[$i];
                $files[$i]="GERBIL";
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/hapinfCV/){
                $HAPINFERXCVfile=$files[$i];
                $files[$i]="HAPINFCV";
                $jugdehapinferx=1;
                $CValgorithms++;
                next;
        }
        if($files[$i]=~/\S/){
                $files[$i]=();
        }
   }
   @files=reverse sort(@files);
   $CVfile="CV.txt";
   $solutionfile="softwaresolutions.txt";
   $cvsolutionfile="CVsolution.txt";
}

$lineinput=0;
$samplenumber=0;
@geno=();
%genotypesequence=();
$sequencelength=0;
open (GENO, "$homedirectory/$genofile");
while(<GENO>){
   if($lineinput!=1){
         /^\s*(\S*)\s*\S*\s*$/;
        $samplenumbergeno=$1;
        /^\s*\S*\s*(\S*)\s*$/;
        $sequencelengthgeno=$1; 
        $lineinput++;
   }else{
         /^\s*(\S*\s*\S*)\s*$/;
         $string=$1;
         $length=length($string);
         $length=$length-10;
         if($length ne $sequencelengthgeno){
            print "The genotypic data may have incorrect sequence length!\n";
            $sequencelength=$length;
         }
         $sequencelength=$length;
         chomp($geno[$samplenumber]=substr($string,0,10));
         $geno[$samplenumber]=~s/\s+//g;
         $genotypesequence{$geno[$samplenumber]}=substr($string,10,$sequencelength);
         $samplenumber++;
   }
}
close GENO;
if($samplenumber ne $samplenumbergeno){
   print "The genotypic data may have incorrect samle number!\n";
}


open (PHASE, $PHASEinfile);
open (PHASEPAIR, $PHASEpairs);
open (HAPINFERX,$HAPINFERXfile);
open (ARLEQUINEM,$ArlequinEMfile);
open (HAPLOREC,$HaploRecfile);
open (HAPLOTYPER,$HAPLOTYPERfile);
open (CHARACTER,$CHARACTERfile);
open (GCHAP,$GCHapfile);
open (HAPINFERXCV,$HAPINFERXCVfile);
open (GERBIL, $GERBILFILE);
open (CV, ">$CVfile");
open (SOLUTION, ">$solutionfile");
open (CVSOLUTION, ">$cvsolutionfile");
if($directoryjudge eq 'n'){
        printf CV "The following files were used in the consensus vote analysis: ";
        for($i=0;$i<$filenumber;$i++){
                printf CV "$files1[$i] ";
        }
        printf CV "\n\n";
}

my(@first_base,@second_base,@third_base);
my(@PHASE,@PHASEpairs,@sample_name,@PHASE_haplotype_count,@PHASE_haplotype,@PHASE_individual_haplotype1,@PHASE_individual_haplotype2,@PHASE_haplotype_pair_probability,@PHASEcompare,@PHASE_haplotype_pair_probability_number);
my(@HAPINFERX,@HAPINFERX_haplotype,@HAPINFERX_individual_haplotype1,@HAPINFERX_individual_haplotype2,@HAPINFERX_haplotype_pair_probability,@HAPINFERXcompare,@HAPINFERX_haplotype_pair_probability_number);
my(@ARLEQUINEM,@ARLEQUINEM_haplotype_count,@ARLEQUINEM_haplotype,@ARLEQUINEM_individual_haplotype1,@ARLEQUINEM_individual_haplotype2,@ARLEQUINEM_haplotype_pair_probability,@ARLEQUINEM_haplotype_pair_probability_number);
my(@HaploRec,@HaploRec_haplotype_count,@HaploRec_haplotype,@HaploRec_individual_haplotype1,@HaploRec_individual_haplotype2,@HaploRec_haplotype_pair_probability,@HaploRec_haplotype_pair_probability_number);
my(@HAPLOTYPER,@HAPLOTYPER_individual_haplotype1,@HAPLOTYPER_individual_haplotype2,@HAPLOTYPER_haplotype_pair_probability,@HAPLOTYPER_haplotype_pair_probability_number);
my(@GCHap,@GCHap_individual_haplotype1,@GCHap_individual_haplotype2,@GCHap_haplotype_pair_probability,@GCHap_haplotype_pair_probability_number);
my(@GCBIL,@GCBIL_individual_haplotype1,@GCBIL_individual_haplotype2);
my(@algorithm,@vote,@CVcompare1,@CVcompare2,@CVhaplotype1,@CVhaplotype2);
my(@samplenumber1);

#read the file including the polymorphic information;
open(CHARACTER,$CHARACTERfile);
$i=0;
@constantsite=();
@first_base=();
@second_base=();
@third_base=();
$allsitenumber=0;
$variablesitenumber=0;
while(<CHARACTER>){
        $site=$_;
        $site=~s/\W+//g;
        $site=~s/\d+//g;
        $nucleotednumber=length($site);
        if($nucleotednumber==1){
                $constantsite[$i]=$site;
                $first_base[$i]=" ";
                $i++;
        }elsif($nucleotednumber==2){
                $constantsite[$i]=" ";
                $first_base[$i]=substr($site,0,1);
                $second_base[$i]=substr($site,1,1);
                $third_base[$i]=" ";
                $variablesitenumber++;
                $i++;
        }elsif($nucleotednumber==3){
                $constantsite[$i]=" ";
                $first_base[$i]=substr($site,0,1);
                $second_base[$i]=substr($site,1,1);
                $third_base[$i]=substr($site,2,1);
                $variablesitenumber++;
                $i++;
        }
        $allsitenumber=$i;
}
close CHARACTER;

#read the output file of PHASE;
@PHASE=<PHASE>;
@PHASEpairs=<PHASEPAIR>;
$linePhASE=(@PHASE);
if($linePhASE>1){
    printf SOLUTION "The solution of PHASE is:\n";
}
$linephasepairs=(@PHASEpairs);
$j=0;
$sample_count=0;
for($i=0;$i<$linePhASE;$i++){
    if($PHASE[$i]=~/Number of Individuals/){
        $temp=$PHASE[$i];
        $sample_number=substr($temp,23,10);
        $sample_number=~s/\s//g;
    }elsif($PHASE[$i]=~/Number of Loci/){
        $temp=$PHASE[$i];
        $site_number=substr($temp,16,10);
        $site_number=~s/\s//g;
    }elsif($PHASE[$i]=~/.000000/){
        $temp=$PHASE[$i];
        $PHASE_haplotype_count[$j]=substr($temp,0,10);
        $PHASE_haplotype_count[$j]=~s/\s//g;
        $temp=substr($temp,11,2*$site_number);
        $temp=~s/1 /1/g;
        $temp=~s/2 /2/g;
        $temp=~s/3 /3/g;
        $temp=~s/4 /4/g;
        $PHASE_haplotype[$j]=substr($temp,0,$site_number);
        $PHASE_haplotype[$j]=~tr/1234/ACGT/;
        $j++;
    }elsif($PHASE[$i]=~/#\S*:/){
        $temp=$PHASE[$i];
        $left=index($temp,"#");
        $right=index($temp,":");
        $sample_name[$sample_count]=substr($temp,$left+1,$right-$left-1);
        $length=length($temp);
        $position=index($temp,"(");
        $position++;
        $temp=substr($temp,$position,$length);
        $position=index($temp,")");
        $temp=substr($temp,0,$position);
        $position1=index($temp,",");  
        $haplotype1=substr($temp,0,$position1);
        $haplotype1--;
        $PHASE_individual_haplotype1[$sample_count]=$PHASE_haplotype[$haplotype1];
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($PHASE_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$sample_name[$sample_count]);
        printf SOLUTION "$temp1\n";
        $PHASE_individual_haplotype1[$sample_count]=$temp1;
        $position1++;
        $temp=substr($temp,$position1,$length);
        $length=length($temp);
        $haplotype2=substr($temp,0,$length);
        $haplotype2--;
        $PHASE_individual_haplotype2[$sample_count]=$PHASE_haplotype[$haplotype2];
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($PHASE_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$sample_name[$sample_count]);
        printf SOLUTION "$temp1\n";
        $PHASE_individual_haplotype2[$sample_count]=$temp1;
        $sample_count++;
    }
}
close PHASE;
$samplenumber1[0]=$sample_count;

$sample_count1=-1;
$j=0;
for($i=0;$i<$linephasepairs;$i++){
    $temp=$PHASEpairs[$i];
    if($temp=~/#/){
        $j=0;
        $sample_count1++;
        @PHASEcompare=();
    }elsif($temp=~/./){
        $temp=~s/\s//g;
        $keep_site=2*$site_number+2;
        $PHASEcompare[$j]=substr($temp,$keep_site,5);
        @PHASEcompare=reverse sort(@PHASEcompare);
        $PHASE_haplotype_pair_probability[$sample_count1]=$PHASEcompare[0];
        $j++;
    }
}
close PHASEPAIR;


$PHASE_number_low_frequency=0;
for($i=0;$i<$sample_number;$i++){
    if($PHASE_haplotype_pair_probability[$i]<0.7){
        $PHASE_haplotype_pair_probability[$i]='-';
        $PHASE_haplotype_pair_probability_number[$i]=0.7;
        $PHASE_number_low_frequency++;
    }else{
        $PHASE_haplotype_pair_probability_number[$i]=1;
        $PHASE_haplotype_pair_probability[$i]='+';
    }
}

#read the output file of HAPINFERX;
%clarkhaplotype1=();
%clarkhaplotype2=();
%clarkfreq=();
@HAPINFERX=<HAPINFERX>;
$lineHAPINFERX=(@HAPINFERX);
$haplotype_count=0;
$sample_count=0;
$skip_line=0;
$k=0;
$judge=0;
$individual=0;
$length=length($HAPINFERX[1]);
for($i=0;$i<$lineHAPINFERX;$i++){
    $temp=$HAPINFERX[$i];
    if($temp=~/TITLE: Hapinfer output data/){
        $skip_line++;
    }
    elsif($temp=~/[0-9]\s:\s[A-Z]/i && $skip_line!=0){
        $temp=~s/\W+//g;
        $temp=~s/\d+//g;
        $HAPINFERX_haplotype[$haplotype_count]=$temp;
        $HAPINFERX_haplotype[$haplotype_count]=~s/\s//g;
        $haplotype_count++;
    }
    elsif($temp=~/number of phenotypes/){
        $judge=1;
    }
    elsif($temp=~/#/ && $judge!=0){
         $name=();
         $name=$temp;
         $name=~s/\W+//g;
        $individual=1;
        $trans=$sample_count;
        @HAPINFERXcompare=();
        $solution_count=0;
    }
    elsif($temp=~/-\s[0-9]*\s1.000000/ && $individual!=0){
        $temp=~s/\D+//g;
        $length=length($temp);
        $templength1=$length-7;
        $haplotype1=substr($temp,0,$templength1);
        $haplotype1--;
        $HAPINFERX_individual_haplotype1[$sample_count]=$HAPINFERX_haplotype[$haplotype1];
        $HAPINFERX_individual_haplotype1[$sample_count]=~tr/acgt/ACGT/;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPINFERX_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        $HAPINFERX_individual_haplotype1[$sample_count]=$temp1;
        $clarkhaplotype1{$name}=$HAPINFERX_individual_haplotype1[$sample_count];
        $k=1;
    }
    elsif($temp=~/-\s[0-9]*/ && $k!=0){
        $temp=~s/\D+//g;
        $haplotype2=$temp;
        $haplotype2--;
        $HAPINFERX_individual_haplotype2[$sample_count]=$HAPINFERX_haplotype[$haplotype2];
        $HAPINFERX_individual_haplotype2[$sample_count]=~tr/acgt/ACGT/;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPINFERX_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        $HAPINFERX_individual_haplotype2[$sample_count]=$temp1;
        $clarkhaplotype2{$name}=$HAPINFERX_individual_haplotype2[$sample_count];
        $k=0;
        $sample_count++;
    }
    elsif($temp=~/-\s[0-9]*\s0./){
        $position=index($temp,".");
        $position--;
        $HAPINFERXcompare[$solution_count]=substr($temp,$position,8);
        @HAPINFERXcompare=reverse sort(@HAPINFERXcompare);
        $HAPINFERX_haplotype_pair_probability[$trans]=$HAPINFERXcompare[0];
        $clarkfreq{$name}=$HAPINFERXcompare[0];
        $solution_count++;
    }
}
close HAPINFERX;
if($lineHAPINFERX>1){
    printf SOLUTION "\nThe solution of HAPINFERX is:\n";
    for($i=0;$i<$sample_count;$i++){
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$i]);
        printf SOLUTION "$clarkhaplotype1{$geno[$i]}\n";
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$i]);
        printf SOLUTION "$clarkhaplotype2{$geno[$i]}\n";
    }
}
$samplenumber1[1]=$sample_count;
for($uu=0;$uu<$sample_count;$uu++){
   $HAPINFERX_individual_haplotype1[$uu]=$clarkhaplotype1{$geno[$uu]};
   $HAPINFERX_individual_haplotype2[$uu]=$clarkhaplotype2{$geno[$uu]};
   $HAPINFERX_haplotype_pair_probability[$uu]=$clarkfreq{$geno[$uu]};
}

$HAPINFERX_low_frequent_count=0;
for($i=0;$i<$sample_count;$i++){
    if($HAPINFERX_haplotype_pair_probability[$i]>0.7){
        $HAPINFERX_haplotype_pair_probability[$i]='-';
        $HAPINFERX_haplotype_pair_probability_number[$i]=0.7;
        $HAPINFERX_low_frequent_count++;
    }else{
        $HAPINFERX_haplotype_pair_probability_number[$i]=1;
        $HAPINFERX_haplotype_pair_probability[$i]='+';
    }
}

#read the ensemble file of HAPINFERX;
my(@HAPINFERXCV,@HAPINFERXCV_individual_haplotype1,@HAPINFERXCV_individual_haplotype2,@HAPINFERXCV_haplotype_pair_probability,@HAPINFERXCV_haplotype_pair_probability_number);
@HAPINFERXCV=<HAPINFERXCV>;
$lineHAPINFERXCV=(@HAPINFERXCV);
close HAPINFERXCV;
if($lineHAPINFERXCV>1){
    printf SOLUTION "\nThe solution of HAPINFERXCV is:\n";
    open (HAPINFERXCV,"$homedirectory/consistencyresult/hapinfCV.txt");
}
$sample_count=0;
$k=0;
$individual=0;
$length=length($HAPINFERXCV[2]);
while(<HAPINFERXCV>){
    if(/^\s*(\#\S*)\s*$/){
      $name=$1;
      $name=~s/\W//g;
      $individual++;
    }
    elsif($individual!=0){
        /^\s*(\S*)\s*\S*\s*$/;
        $HAPINFERXCV_individual_haplotype1[$sample_count]=$1;
        /^\s*\S*\s*(\S*)\s*$/;
        $HAPINFERXCV_haplotype_pair_probability[$sample_count]=$1;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPINFERXCV_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        $HAPINFERXCV_individual_haplotype1[$sample_count]=$temp1;
        $clarkfreq{$name}=$HAPINFERXCV_haplotype_pair_probability[$sample_count];
        $clarkhaplotype1{$name}=$temp1;
        $individual=0;
        $k=1;
    }
    elsif($k!=0){
        /^\s*(\S*)\s*$/;
        $HAPINFERXCV_individual_haplotype2[$sample_count]=$1;;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPINFERXCV_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        $HAPINFERXCV_individual_haplotype2[$sample_count]=$temp1;
        $clarkhaplotype2{$name}=$temp1;
        $k=0;
        $sample_count++;
    }
}
close HAPINFERXCV;
if($lineHAPINFERXCV>1){
    for($i=0;$i<$sample_count;$i++){
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$i]);
        printf SOLUTION "$clarkhaplotype1{$geno[$i]}\n";
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$i]);
        printf SOLUTION "$clarkhaplotype2{$geno[$i]}\n";
    }
}
$samplenumber1[2]=$sample_count;
for($uu=0;$uu<$sample_count;$uu++){
   $HAPINFERXCV_individual_haplotype1[$uu]=$clarkhaplotype1{$geno[$uu]};
   $HAPINFERXCV_individual_haplotype2[$uu]=$clarkhaplotype2{$geno[$uu]};
   $HAPINFERXCV_haplotype_pair_probability[$uu]=$clarkfreq{$geno[$uu]};
}

$HAPINFERXCV_low_frequent_count=0;
for($i=0;$i<$sample_count;$i++){
    if($HAPINFERXCV_haplotype_pair_probability[$i]<0.7){
        $HAPINFERXCV_haplotype_pair_probability[$i]='-';
        $HAPINFERXCV_haplotype_pair_probability_number[$i]=0.7;
        $HAPINFERXCV_low_frequent_count++;
    }else{
        $HAPINFERXCV_haplotype_pair_probability_number[$i]=1;
        $HAPINFERXCV_haplotype_pair_probability[$i]='+';
    }
}


#read the output file of ARLEQUINEM;
@ArlequinEM=<ARLEQUINEM>;
$lineArlequinEM=(@ArlequinEM);
if($lineArlequinEM>1){
    printf SOLUTION "\nThe solution of ArlequinEM is:\n";
}
$j=0;
$judge=0;
$sample_count=0;
for($i=0;$i<$lineArlequinEM;$i++){
    if($ArlequinEM[$i]=~/UNKNOWN/){
        $temp=$ArlequinEM[$i];
        $position=index($temp,'U');
        $ARLEQUINEM_haplotype_count[$j]=substr($temp,0,$position);
        $ARLEQUINEM_haplotype_count[$j]=~s/\s//g;
        $length1=length($temp);
        $length2=$length1-$position-10;
        $position=$position+10;
        $temp1=substr($temp,$position,$length2);
        $ARLEQUINEM_haplotype[$j]=$temp1;
        $ARLEQUINEM_haplotype[$j]=~s/\s//g;
        $ARLEQUINEM_haplotype[$j]=~s/\.//g;
        $ARLEQUINEM_haplotype[$j]=~s/\d//g;
        $j++;
    }
    elsif($ArlequinEM[$i]=~/Phenotype #/){
        $k=0;
    }
    elsif($ArlequinEM[$i]=~/1\s*[0-9].[0-9]*\s*0./ && $k==8){
        $temp=$ArlequinEM[$i];
        $position=index($temp,'.');
        $ARLEQUINEM_haplotype_pair_probability[$sample_count]=substr($temp,$position-1,8);
        $haplotype1=substr($temp,40,6);
        $haplotype1=~s/\s//g;
        $haplotype1--;
        $ARLEQUINEM_individual_haplotype1[$sample_count]=$ARLEQUINEM_haplotype[$haplotype1];
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($ARLEQUINEM_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $ARLEQUINEM_individual_haplotype1[$sample_count]=$temp1;
        $judge=1;
        $k++;
    }
    elsif($judge!=0){
        $temp=$ArlequinEM[$i];
        $temp=substr($temp,40,6);
        $haplotype2=$temp;
        $haplotype2=~s/\s//g;
        $haplotype2--;
        $ARLEQUINEM_individual_haplotype2[$sample_count]=$ARLEQUINEM_haplotype[$haplotype2];
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($ARLEQUINEM_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $ARLEQUINEM_individual_haplotype2[$sample_count]=$temp1;
        $judge=0;
        $sample_count++;
    }
    $k++;
}

close ARLEQUINEM;
$samplenumber1[3]=$sample_count;

$ARLEQUINEM_Low_frequency_count=0;
for($i=0;$i<$sample_count;$i++){
    if($ARLEQUINEM_haplotype_pair_probability[$i]<0.7){
        $ARLEQUINEM_haplotype_pair_probability[$i]='-';
        $ARLEQUINEM_haplotype_pair_probability_number[$i]=0.7;
        $ARLEQUINEM_Low_frequency_count++;
    }else{
        $ARLEQUINEM_haplotype_pair_probability_number[$i]=1;
        $ARLEQUINEM_haplotype_pair_probability[$i]='+';
    }
}
    
#read the output file of HAPLOREC;
@HaploRec=<HAPLOREC>;
$lineHaploRec=(@HaploRec);
if($lineHaploRec>1){
    printf SOLUTION "\nThe solution of HaploRec is:\n";
}
$sample_count=0;
for($i=0;$i<$lineHaploRec;$i++){
    if($HaploRec[$i]=~/Id/){
        $temp=$HaploRec[$i];
        $position=index($temp,'CONFIDENCE');
        $temp=substr($temp,3,$position-3);
        $temp=~s/[0-9]*\s/A/g;
        $site_number=length($temp);
        $j=1;
    }
    elsif($j!=0){
        $temp=$HaploRec[$i];
        $position=index($temp,' ');
        $position1=index($temp,'-');
        $temp1=substr($temp,$position+1,2*$site_number);
        $frequency=$position1-$position-2*$site_number-2;
        $HaploRec_haplotype_pair_probability[$sample_count]=substr($temp,$position+1+2*$site_number,$frequency);
        $temp1=~s/\s//g;
        $temp1=~tr/1234/ACGT/;
        $HaploRec_individual_haplotype1[$sample_count]=$temp1;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HaploRec_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $HaploRec_individual_haplotype1[$sample_count]=$temp1;
        $j=0;
        $judge=1;
    }
    elsif($judge==1){
        $temp=$HaploRec[$i];
        $temp=substr($temp,$position+1,2*$site_number);
        $temp=~s/\s//g;
        $temp=~tr/1234/ACGT/;
        $HaploRec_individual_haplotype2[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HaploRec_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $HaploRec_individual_haplotype2[$sample_count]=$temp1;
        $j=1;
        $judge=0;
        $sample_count++;
    }
}
close HAPLOREC;
$samplenumber1[4]=$sample_count;

$HaploRec_Low_frequency_count=0;
for($i=0;$i<$sample_count;$i++){
    if($HaploRec_haplotype_pair_probability[$i]<0.5 && $HaploRec_haplotype_pair_probability[$i]!=0){
        $HaploRec_haplotype_pair_probability[$i]='-';
        $HaploRec_haplotype_pair_probability_number[$i]=0;
        $HaploRec_Low_frequency_count++;
    }else{
        $HaploRec_haplotype_pair_probability_number[$i]=$HaploRec_haplotype_pair_probability[$i];
        $HaploRec_haplotype_pair_probability[$i]='+';
    }
}

$HaploRec_haplotype_count=0;
$HaploRec_haplotype[0]=$HaploRec_individual_haplotype1[0];
for($i=0;$i<$sample_count;$i++){
    $judge=0;
    for($j=0;$j<$HaploRec_haplotype_count;$j++){
        if($HaploRec_individual_haplotype1[$i] ne $HaploRec_haplotype[$j]){
            $judge++;
        }
    }
    if($judge>=$HaploRec_haplotype_count){
        $HaploRec_haplotype[$HaploRec_haplotype_count]=$HaploRec_individual_haplotype1[$i];
        $HaploRec_haplotype_count++;
    }
}

for($i=0;$i<$sample_count;$i++){
    $judge=0;
    for($j=0;$j<$HaploRec_haplotype_count;$j++){
        if($HaploRec_individual_haplotype2[$i] ne $HaploRec_haplotype[$j]){
            $judge++;
        }
    }
    if($judge>=$HaploRec_haplotype_count){
        $HaploRec_haplotype[$HaploRec_haplotype_count]=$HaploRec_individual_haplotype2[$i];
        $HaploRec_haplotype_count++;
    }
}

#read the output file of HAPLOTYPER;
@HAPLOTYPER=<HAPLOTYPER>;
$lineHAPLOTYPER=(@HAPLOTYPER);
if($lineHAPLOTYPER>1){
    printf SOLUTION "\nThe solution of HAPLOTYPER is:\n";
}
$sample_count=0;
$judge=0;
for($i=0;$i<$lineHAPLOTYPER;$i++){
    if($HAPLOTYPER[$i]=~/---/){
        $temp=$HAPLOTYPER[$i];
        $position=index($temp,'.');
        $HAPLOTYPER_haplotype_pair_probability[$sample_count]=substr($temp,$position-1,7);
        $judge=1;
    }
    elsif($judge==1){
        $temp=$HAPLOTYPER[$i];
        $temp=~s/\s//;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transHAPLOTYPER($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $HAPLOTYPER_individual_haplotype1[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPLOTYPER_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $HAPLOTYPER_individual_haplotype1[$sample_count]=$temp1;
        $judge++;
    }
    elsif($judge==2){
        $temp=$HAPLOTYPER[$i];
        $temp=~s/\s//;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transHAPLOTYPER($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $HAPLOTYPER_individual_haplotype2[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($HAPLOTYPER_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $HAPLOTYPER_individual_haplotype2[$sample_count]=$temp1;
        $judge=0;
        $sample_count++;
    }
}

close HAPLOTYPER;
$samplenumber1[5]=$sample_count;

#exclude the abnormal underestimates of some common genotypes in HAPLOTYPER;
if($lineHAPLOTYPER>1){
  @htysequ=();
  @htydistinctgeno=();
  @htydistinctgenofreq=();
  @htydistinctgenoestimatefreq=();
  for($i=0;$i<$sample_count;$i++){
    for($j=0;$j<$allsitenumber;$j++){
        $nucleotidea=substr($HAPLOTYPER_individual_haplotype1[$i],$j,1);
        $nucleotideb=substr($HAPLOTYPER_individual_haplotype2[$i],$j,1);
        if($nucleotidea eq $nucleotideb){
                $htysequ[$i]=$htysequ[$i].$nucleotidea;
        }else{
                $temp=$nucleotidea.$nucleotideb;
                $temp=~s/AC/M/;
                $temp=~s/CA/M/;
                $temp=~s/CG/S/;
                $temp=~s/GC/S/;
                $temp=~s/CT/Y/;
                $temp=~s/TC/Y/;
                $temp=~s/GT/K/;
                $temp=~s/TG/K/;
                $temp=~s/AT/W/;
                $temp=~s/TA/W/;
                $temp=~s/AG/R/;
                $temp=~s/GA/R/;
                $htysequ[$i]=$htysequ[$i].$temp;
        }
    }
  }
  $htydistinctgeno[0]=$htysequ[0];
  $htydistinctgenofreq[0]=1;
  $htydistinctgenoestimatefreq[0]=$HAPLOTYPER_haplotype_pair_probability[0];
  for($i=1;$i<$sample_count;$i++){
   $distinctgeno=@htydistinctgeno;
   $mm=0;
   for($j=0;$j<$distinctgeno;$j++){
      if($htysequ[$i] eq $htydistinctgeno[$j]){
         $htydistinctgenofreq[$j]++;
         last;
      }
      $mm++;
      if($mm eq $distinctgeno){
         $htydistinctgeno[$mm]=$htysequ[$i];
         $htydistinctgenofreq[$mm]=1;
         $htydistinctgenoestimatefreq[$mm]=$HAPLOTYPER_haplotype_pair_probability[$i];
      }
   }
  }
  $distinctgeno=@htydistinctgeno;
  for($j=0;$j<$distinctgeno;$j++){
   if(($htydistinctgenofreq[$j]>7) && ($htydistinctgenoestimatefreq[$j]<0.7)){
      $htydistinctgenoestimatefreq[$j]=1;
   }
  }
  @HAPLOTYPER_haplotype_pair_probability_revised=();
  for($i=0;$i<$sample_count;$i++){
   for($j=0;$j<$distinctgeno;$j++){
      if($htysequ[$i] eq $htydistinctgeno[$j]){
         $HAPLOTYPER_haplotype_pair_probability_revised[$i]=$htydistinctgenoestimatefreq[$j];
         last;
      }
   }
  }
  for($i=0;$i<$sample_count;$i++){
   if($HAPLOTYPER_haplotype_pair_probability_revised[$i]<0.7){
      $HAPLOTYPER_haplotype_pair_probability_number[$i]=0.7;
   }else{
      $HAPLOTYPER_haplotype_pair_probability_number[$i]=1;
   }
  }
}

$HAPLOTYPER_low_frequency_count=0;
for($k=0;$k<$sample_count;$k++){
    if($HAPLOTYPER_haplotype_pair_probability[$k]<0.7){
        $HAPLOTYPER_haplotype_pair_probability[$k]='-';
        $HAPLOTYPER_low_frequency_count++;
    }else{
        $HAPLOTYPER_haplotype_pair_probability[$k]='+';
    }
}

#read the output file of GCHAP;
@GCHap=<GCHAP>;
$lineGCHap=(@GCHap);
if($lineGCHap>1){
    printf SOLUTION "\nThe solution of GCHap is:\n";
}
$sample_count=0;
$judge=0;
for($i=0;$i<$lineGCHap;$i++){
    if($GCHap[$i]=~/Best explanation/){
        $judge=1;
    }
    elsif($judge==1){
        $temp=$GCHap[$i];
        $temp=~s/\s//g;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transGCHap($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $GCHap_individual_haplotype1[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($GCHap_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $GCHap_individual_haplotype1[$sample_count]=$temp1;
        $judge++;
    }
    elsif($judge==2){
        $temp=$GCHap[$i];
        $temp=~s/\s//g;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transGCHap($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $GCHap_individual_haplotype2[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($GCHap_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $GCHap_individual_haplotype2[$sample_count]=$temp1;
        $judge++;
    }
    elsif($judge==3){
        $GCHap_haplotype_pair_probability[$sample_count]=$GCHap[$i];
        $GCHap_haplotype_pair_probability[$sample_count]=~s/\s//g;
        $judge=0;
        $sample_count++;
    }
}
close GCHAP;
$samplenumber1[6]=$sample_count;


$GCHap_low_frequency_count=0;
for($k=0;$k<$sample_count;$k++){
    $GCHap_haplotype_pair_probability[$k]=~s/%//g;
    if($GCHap_haplotype_pair_probability[$k]<70){
        $GCHap_haplotype_pair_probability[$k]='-';
        $GCHap_haplotype_pair_probability_number[$k]=0.7;
        $GCHap_low_frequency_count++;
    }else{
        $GCHap_haplotype_pair_probability_number[$k]=1;
        $GCHap_haplotype_pair_probability[$k]='+';
    }
}

#read the output file of GERBIL;
open (GERBIL, $GERBILFILE);
@GERBIL=<GERBIL>;
$lineGERBIL=(@GERBIL);
if($lineGERBIL>1){
    printf SOLUTION "\nThe solution of GERBIL is:\n";
}
$sample_count=0;
$judge=0;
for($i=0;$i<$lineGERBIL;$i++){
    if($judge==0){
        $temp=$GERBIL[$i];
        $temp=~s/\s+//g;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transGERBIL($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $GERBIL_individual_haplotype1[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($GERBIL_individual_haplotype1[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "a";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $GERBIL_individual_haplotype1[$sample_count]=$temp1;
        $judge++;
    }elsif($judge==1){
        $temp=$GERBIL[$i];
        $temp=~s/\s+//g;
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
            $transition=&tri_transGERBIL($first_base[$j],$second_base[$j],$third_base[$j],$temp,$y,$sample_count);
            $temp=$transition;
            $y++;
            }
        }
        $GERBIL_individual_haplotype2[$sample_count]=$temp;
        $temp1=();
        $y=0;
        for($j=0;$j<$allsitenumber;$j++){
            if($first_base[$j]=~/\S/){
                $tempnucleotide=substr($GERBIL_individual_haplotype2[$sample_count],$y,1);
                $temp1=$temp1.$tempnucleotide;
                $y++;
            }
            if($first_base[$j]=~/\s/){
                $temp1=$temp1.$constantsite[$j];
            }
        }
        printf SOLUTION "b";
        printf SOLUTION ("%-10s",$geno[$sample_count]);
        printf SOLUTION "$temp1\n";
        $GERBIL_individual_haplotype2[$sample_count]=$temp1;
        $judge++;
        $sample_count++;
    }elsif($judge==2){
        $judge=0;
    }
}

close GERBIL;
$samplenumber1[7]=$sample_count;
@samplenumber1=reverse sort(@samplenumber1);
$sample_count=$samplenumber1[0];
%NDH=();
$NDH{PHASE}=&haplotype_count(@PHASE_individual_haplotype1,@PHASE_individual_haplotype2);
$NDH{HAPINFERX}=&haplotype_count(@HAPINFERX_individual_haplotype1,@HAPINFERX_individual_haplotype2);
$NDH{HAPINFCV}=&haplotype_count(@HAPINFERXCV_individual_haplotype1,@HAPINFERXCV_individual_haplotype2);
$NDH{ARLEQUINEM}=&haplotype_count(@ARLEQUINEM_individual_haplotype1,@ARLEQUINEM_individual_haplotype2);
$NDH{HAPLOREC}=&haplotype_count(@HaploRec_individual_haplotype1,@HaploRec_individual_haplotype2);
$NDH{HAPLOTYPER}=&haplotype_count(@HAPLOTYPER_individual_haplotype1,@HAPLOTYPER_individual_haplotype2);
$NDH{GCHap}=&haplotype_count(@GCHap_individual_haplotype1,@GCHap_individual_haplotype2);
$NDH{GERBIL}=&haplotype_count(@GERBIL_individual_haplotype1,@GERBIL_individual_haplotype2);
@xxx=keys(%NDH);
printf CV "\nThe numbers of distinct haplotypes in the solutions are as follows:\n";
foreach (@xxx){
        if($NDH{$_}>0){
                printf CV "$_: $NDH{$_}\n";
        }
}

printf CV "\nThe information of probability is as follows (order-";
for($i=0;$i<$CValgorithms;$i++){
    printf CV "$files[$i] ";
}
printf CV "):\n";
printf CV "\n";
printf CV ("%-9s","Number");
printf CV ("%-15s","Sample");
printf CV ("%-26s","Confidence probabilities");
printf CV ("%-25s","Solution status");
printf CV ("%-30s","Vote number of CV solution");
printf CV ("%-25s","CV solution");
printf CV ("%-60s","Algorithm assignment group");
$Homozygote=0;
$Well_supported=0;
$contry=0;
%dicordancename=();
$fullsportlowvote=0;
%lowvote=();
my(%lowfrequency,%CVcompare1,%CVcompare2);
@CVsolution1=();
@CVsolution2=();
%CV1=();
%CV2=();
$cvsolutionhap=2*$sample_count;
printf CVSOLUTION "$cvsolutionhap "."$allsitenumber\n";

#consensus vote analysis;
if($CValgorithms<3){
   print "\nThe number of algorithms should be more than two in the consensus vote analysis\n";
   exit;
}
for($i=0;$i<$sample_count;$i++){
    $x=0;
    $x=1+$i;
    printf CV ("\n%-9d",$x);
   printf CV ("%-15s",$geno[$i]);
    %lowfrequency=();
    %lowfrequency_number=();
    %CVcompare1=();
    %CVcompare2=();
    for($q=0;$q<$CValgorithms;$q++){
        if($files[$q]=~/PHASE/){
            $lowfrequency{$files[$q]}=$PHASE_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$PHASE_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$PHASE_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$PHASE_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/HAPINFERX/){
            $lowfrequency{$files[$q]}=$HAPINFERX_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$HAPINFERX_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$HAPINFERX_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$HAPINFERX_individual_haplotype2[$i];
            $HAPINFERHAP1=$HAPINFERX_individual_haplotype1[$i];
            $HAPINFERHAP2=$HAPINFERX_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/HAPINFCV/){
            $lowfrequency{$files[$q]}=$HAPINFERXCV_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$HAPINFERXCV_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$HAPINFERXCV_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$HAPINFERXCV_individual_haplotype2[$i];
            $HAPINFERHAP1=$HAPINFERXCV_individual_haplotype1[$i];
            $HAPINFERHAP2=$HAPINFERXCV_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/ARLEQUINEM/){
            $lowfrequency{$files[$q]}=$ARLEQUINEM_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$ARLEQUINEM_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$ARLEQUINEM_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$ARLEQUINEM_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/HAPLOREC/){
            $lowfrequency{$files[$q]}=$HaploRec_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=1;                                      
            $CVcompare1{$files[$q]}=$HaploRec_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$HaploRec_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/HAPLOTYPER/){
            $lowfrequency{$files[$q]}=$HAPLOTYPER_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$HAPLOTYPER_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$HAPLOTYPER_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$HAPLOTYPER_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/GCHap/){
            $lowfrequency{$files[$q]}=$GCHap_haplotype_pair_probability[$i];
            $lowfrequency_number{$files[$q]}=$GCHap_haplotype_pair_probability_number[$i];
            $CVcompare1{$files[$q]}=$GCHap_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$GCHap_individual_haplotype2[$i];
        }
        elsif($files[$q]=~/GERBIL/){
            $lowfrequency{$files[$q]}="NA ";
            $lowfrequency_number{$files[$q]}=1;
            $CVcompare1{$files[$q]}=$GERBIL_individual_haplotype1[$i];
            $CVcompare2{$files[$q]}=$GERBIL_individual_haplotype2[$i];
        }
    }
    @haplotype1=();
    @haplotype2=();
    $haplotypelink1=();
    $haplotypelink2=();
    for($q=0;$q<$CValgorithms;$q++){
        $haplotype1[$q]=$CVcompare1{$files[$q]};
        $haplotypelink1="$CVcompare1{$files[$q]}"."-"."$haplotypelink1";
        $haplotype2[$q]=$CVcompare2{$files[$q]};
        $haplotypelink2="$CVcompare2{$files[$q]}"."-"."$haplotypelink2";
        printf CV ("%-2s",$lowfrequency{$files[$q]});
    }
    printf CV "              ";
    $CVsolution_count=&solution_count(@haplotype1,@haplotype2);
    if($CVsolution_count eq 'Homozygote'){
        printf CV ("%-25s",$CVsolution_count);
        printf CV ("%-55s","NA");
        printf CV ("%-25s\n","NA");
        $CVsolution1[$i]=$haplotype1[0];
        $CVsolution2[$i]=$haplotype2[0];
        printf CVSOLUTION "a";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution1[$i]\n";
        printf CVSOLUTION "b";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution2[$i]\n";
        $CV1{$geno[$i]}=$CVsolution1[$i];
        $CV2{$geno[$i]}=$CVsolution2[$i];
        $Homozygote++;
    }
    elsif($CVsolution_count==1){
        $votevalue=0;
        for($q=0;$q<$CValgorithms;$q++){
                $votevalue+=$lowfrequency_number{$files[$q]};
        }
        printf CV ("%-25s","Fully supported");
        printf CV ("%-55s","$votevalue vote");
        printf CV ("%-25s\n","(All algorithms)");
        if($votevalue<$CValgorithms){
                $lowvote{$i}=$geno[$i];
                $fullsportlowvote++;
        }
        $CVsolution1[$i]=$haplotype1[0];
        $CVsolution2[$i]=$haplotype2[0];
        printf CVSOLUTION "a";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution1[$i]\n";
        printf CVSOLUTION "b";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution2[$i]\n";
        $CV1{$geno[$i]}=$CVsolution1[$i];
        $CV2{$geno[$i]}=$CVsolution2[$i];
        $Well_supported++;
    }
    elsif($CVsolution_count>1){
        $dicordancename{$i}=$geno[$i];
        $contry++;
        printf CV ("%-2s",$CVsolution_count);
        printf CV ("%-23s","solutions"); 
        $CVsolution_returnhaplotype=&solution_haplotype($haplotypelink1,$haplotypelink2,$CValgorithms,$CVsolution_count);
        @CVsolution_haplotype=split(/-/,$CVsolution_returnhaplotype);
        @CVsolution_haplotype=reverse sort(@CVsolution_haplotype);
        @votevalue=();
        @votehaplotype1=();
        @votehaplotype2=();
        for($t=0;$t<$CVsolution_count;$t++){
            for($q=0;$q<$CValgorithms;$q++){
                if(($CVsolution_haplotype[$t] eq $CVcompare1{$files[$q]}) || ($CVsolution_haplotype[$t] eq $CVcompare2{$files[$q]})){
                    $votevalue[$t]+=$lowfrequency_number{$files[$q]};
                    $votehaplotype1[$t]=$CVcompare1{$files[$q]};
                    $votehaplotype2[$t]=$CVcompare2{$files[$q]};                            
                }
            }
        }
        $max=0;
        for($t=0;$t<$CVsolution_count;$t++){
            if($max<$votevalue[$t]){
                $max=$votevalue[$t];
            }
        }
        $judegevotevalue=0;
        for($t=0;$t<$CVsolution_count;$t++){
            if($max eq $votevalue[$t]){
                $judegevotevalue++;
                $CVsolution1[$i]=$votehaplotype1[$t];
                $CVsolution2[$i]=$votehaplotype2[$t];
            }
        }
        if($judegevotevalue > 1){
            @equvotehaplotype1=();
            @equvotehaplotype2=();
            for($q=0;$q<$judegevotevalue;$q++){
                for($t=0;$t<$CVsolution_count;$t++){
                        if($max eq $votevalue[$t]){
                               $equvotehaplotype1[$q]=$votehaplotype1[$t];
                               $equvotehaplotype2[$q]=$votehaplotype2[$t];
                               $votevalue[$t]=0;
                               last;
                        }
                }
            }
            $equvotenumber=(@equvotehaplotype1);
            if($jugdehapinferx == 1){
                for($w=0;$w<$judegevotevalue;$w++){
                        if(($equvotehaplotype1[$w] eq $HAPINFERXCV_individual_haplotype1[$i]) || ($equvotehaplotype1[$w] eq $HAPINFERXCV_individual_haplotype2[$i])){
                                $equvotehaplotype1[$w]=();
                                $equvotehaplotype2[$w]=();
                                $equvotenumber--;
                                last;
                        }
                        if(($equvotehaplotype1[$w] eq $HAPINFERX_individual_haplotype1[$i]) || ($equvotehaplotype1[$w] eq $HAPINFERX_individual_haplotype2[$i])){
                                $equvotehaplotype1[$w]=();
                                $equvotehaplotype2[$w]=();
                                $equvotenumber--;
                                last;
                        }
                }
            }
            if($equvotenumber == 1){
                @equvotehaplotype1=reverse sort(@equvotehaplotype1);
                @equvotehaplotype2=reverse sort(@equvotehaplotype2);
                $CVsolution1[$i]=$equvotehaplotype1[0];
                $CVsolution2[$i]=$equvotehaplotype2[0];
                
            }
            if($equvotenumber > 1){
                $maxNDH=0;
                for($w=0;$w<$equvotenumber;$w++){
                        for($q=0;$q<$CValgorithms;$q++){
                                if(($equvotehaplotype1[$w] eq $CVcompare1{$files[$q]}) || ($equvotehaplotype1[$w] eq $CVcompare2{$files[$q]})){
                                        if($maxNDH < $NDH{$files[$q]}){
                                                $maxNDH=$NDH{$files[$q]};
                                        }
                                }
                        }
                }
                for($w=0;$w<$equvotenumber;$w++){
                        for($q=0;$q<$CValgorithms;$q++){
                                if(($equvotehaplotype1[$w] eq $CVcompare1{$files[$q]}) || ($equvotehaplotype1[$w] eq $CVcompare2{$files[$q]})){
                                        if($maxNDH eq $NDH{$files[$q]}){
                                                $equvotehaplotype1[$w]=();
                                                $equvotehaplotype2[$w]=();
                                                last;
                                        }
                                }
                        }
                }               
                for($w=0;$w<$judegevotevalue;$w++){
                  if($equvotehaplotype1[$w]){
                        $CVsolution1[$i]=$equvotehaplotype1[$w];
                        $CVsolution2[$i]=$equvotehaplotype2[$w];
                        last;
                  }
                }
            }
            
        }
        printf CV ("%-30s","$max vote");
        printf CVSOLUTION "a";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution1[$i]\n";
        printf CVSOLUTION "b";
        printf CVSOLUTION ("%-10s",$geno[$i]);
        printf CVSOLUTION "$CVsolution2[$i]\n";
        $CV1{$geno[$i]}=$CVsolution1[$i];
        $CV2{$geno[$i]}=$CVsolution2[$i];
        for($t=0;$t<$CValgorithms;$t++){
            if(($CVsolution1[$i] eq $CVcompare1{$files[$t]}) || ($CVsolution1[$i] eq $CVcompare2{$files[$t]})){
                printf CV ("%-25s",$files[$t]);
                last;
            }
        }
        for($t=0;$t<$CVsolution_count;$t++){
            printf CV "(";
            for($q=0;$q<$CValgorithms;$q++){
                if(($CVsolution_haplotype[$t] eq $CVcompare1{$files[$q]}) || ($CVsolution_haplotype[$t] eq $CVcompare2{$files[$q]})){
                    printf CV "$files[$q]"." ";
                }
            }
            printf CV ") ";
        }
        printf CV "\n";
    }
}



close SOLUTION;
close CVSOLUTION;
printf CV "\n###########################################################Summary#######################################################################################################################\n";
printf CV "      *    There are ".$Homozygote." homozygotes.\n";
printf CV "      *    ".$Well_supported." heterozygotes, including some one-site heterozygotes, are supported by all algorithms used, but $fullsportlowvote of which are not obtained all votes.\n";
printf CV "      *    ".$contry." heterozygotes have more than one solutions.\n";
printf CV "      *    - denotes the low probability, + denotes the high probability\n";
printf CV "      *    Here, low confidence probability means that the probability value is less than a simple threshold (e.g. <0.7 for PHASE)\n";
printf CV "      *    For HaploRec, the probability information in the consensus vote analysis has been omitted due to the common biased underestimates from systematic problems\n";
printf CV "      *    NA, not applicable.\n";
printf CV "#########################################################################################################################################################################################\n";

printf CV "\n\nThe following $contry heterozygotes have discordance among algorithms used:\n";
@keys=keys(%dicordancename);
@keys=(sort{$a<=>$b}@keys);
foreach (@keys){
        $temp=$_+1;
        printf CV "$temp $dicordancename{$_}\n";
}
printf CV "\n\nThe following $fullsportlowvote heterozygotes do not show discordance among algorithms used, but did not obtain all votes due to low confidence probability:\n";
@keys=keys(%lowvote);
@keys=(sort{$a<=>$b}@keys);
foreach (@keys){
        $temp=$_+1;
        printf CV "$temp $lowvote{$_}\n";
}

#check possible mismatch bewteen genotypic data and the consensus haplotypes!
%CVgenosequence=();
for($i=0;$i<$samplenumber;$i++){
   $temp=();
   $temp1=$CV1{$geno[$i]};
   $temp2=$CV2{$geno[$i]};
   for($j=0;$j<$sequencelength;$j++){
         $nucleotidea=substr($temp1,$j,1);
         $nucleotideb=substr($temp2,$j,1);
         $state=&statejudge($nucleotidea,$nucleotideb);
         $temp=$temp.$state;
   }
   $CVgenosequence{$geno[$i]}=$temp;
}
$matchnumber=0;
@unmatched=();
$unmatchnumber=0;
for($i=0;$i<$samplenumber;$i++){
    if($CVgenosequence{$geno[$i]} eq $genotypesequence{$geno[$i]}){
        $matchnumber++;
    }else{
        $unmatched[$unmatchnumber]=$geno[$i];
        $unmatchnumber++;
    }
}
if($matchnumber eq $samplenumber){
   print "\nFine, no samples show any mismatch between the inferred and original genotypes!\n";
   printf CV "\nFine, no samples show any mismatch between the inferred and original genotypes!\n";
}
if($unmatchnumber>0){
   print "\nThe following samples have some mismatch(es) between the inferred and original genotypes:\n";
   printf CV "\nThe following samples have some mismatch(es) between the inferred and original genotypes:\n";
   for($i=0;$i<$unmatchnumber;$i++){
      print "$unmatched[$i] ";
      printf CV "$unmatched[$i] ";
   }
}

print "\nThe consensus vote analysis has finished!\n";

exit;

sub tri_transHAPLOTYPER{
    my($first,$second,$third,$string,$m,$n)=@_;
        if($third=~/\s/){
            $length=length($string);
            $stringa=substr($string,0,$m+1);
            $stringb=substr($string,$m+1,$length-$m-1);
            $stringa=~s/0/$first/;
            $stringa=~s/1/$second/;
            $trans=$stringa.$stringb;
            return $trans;
        }
        elsif($third=~/\S/){
            $length=length($string);
            $stringa=substr($string,0,$m+2);
            $stringb=substr($string,$m+2,$length-$m-2);
            $stringa=~s/00/$first/;
            $stringa=~s/01/$second/;
            $stringa=~s/10/$third/;
            $m++;
            $n++;
            if($stringa=~/11/){
                printf CV "#################################################################################################################################################################################\n";
                printf CV "###########################################################Note: There is a Swith coding error in the $m variable site of $n individual.HAPLOTYPER######################################################\n";
                printf CV "#################################################################################################################################################################################\n";
                }
            $trans=$stringa.$stringb;
            return $trans;
        }
    }

sub tri_transGCHap{
    my($first,$second,$third,$string,$m,$n)=@_;
        if($third=~/\s/){
            $length=length($string);
            $stringa=substr($string,0,$m+1);
            $stringb=substr($string,$m+1,$length-$m-1);
            $stringa=~s/1/$first/;
            $stringa=~s/2/$second/;
            $trans=$stringa.$stringb;
            return $trans;
        }
        elsif($third=~/\S/){
            $length=length($string);
            $stringa=substr($string,0,$m+2);
            $stringb=substr($string,$m+2,$length-$m-2);
            $stringa=~s/11/$first/;
            $stringa=~s/12/$second/;
            $stringa=~s/21/$third/;
            $m++;
            $n++;
            if($stringa=~/22/){
                printf CV "#################################################################################################################################################################################\n";
                printf CV "###########################################################Note: There is a swith coding error in the $m variable site of $n individual.GCHap###########################################################\n";
                printf CV "#################################################################################################################################################################################\n";
                }
            $trans=$stringa.$stringb;
            return $trans;
        }
    }


sub tri_transGERBIL{
    my($first,$second,$third,$string,$m,$n)=@_;
        if($third=~/\s/){
            $length=length($string);
            $stringa=substr($string,0,$m+1);
            $stringb=substr($string,$m+1,$length-$m-1);
            $stringa=~s/0/$first/;
            $stringa=~s/1/$second/;
            $trans=$stringa.$stringb;
            return $trans;
        }
        elsif($third=~/\S/){
            $length=length($string);
            $stringa=substr($string,0,$m+2);
            $stringb=substr($string,$m+2,$length-$m-2);
            $stringa=~s/00/$first/;
            $stringa=~s/01/$second/;
            $stringa=~s/10/$third/;
            $m++;
            $n++;
            if($stringa=~/11/){
                printf CV "#################################################################################################################################################################################\n";
                printf CV "###########################################################Note: There is a Swith coding error in the $m variable site of $n individual.GERBIL######################################################\n";
                printf CV "#################################################################################################################################################################################\n";
                }
            $trans=$stringa.$stringb;
            return $trans;
        }
    }

sub solution_count{
    my(@haplotype)=@_;
    $solution_count=("Homozygote");
    %temp=();
    foreach (@haplotype){
        chomp($_);
        $temp{$_}=1;
    }
    @uniquehaplotype=keys %temp;
    $count=(@uniquehaplotype);
    if($count==1){
        return $solution_count;
    }else{
        $solution_count=$count/2;
        return $solution_count;
    }
}

sub solution_haplotype{
    my($hty1,$hty2,$algnumber,$solucount)=@_;
    @htyp1=split(/-/,$hty1);
    @htyp2=split(/-/,$hty2);
    $returnhaplotype=();
    for($w=0;$w<$solucount;$w++){
        for($r=0;$r<=$algnumber;$r++){
            if($htyp1[$r]=~/\w/){
                $unihaplo[$w]=$htyp1[$r];
                $returnhaplotype="$unihaplo[$w]"."-"."$returnhaplotype";
                $htyp1[$r]=();
                $htyp2[$r]=();
                last;
            }
        }
        for($r=0;$r<=$algnumber;$r++){
            if(($unihaplo[$w] eq $htyp1[$r]) || ($unihaplo[$w] eq $htyp2[$r])){
                $htyp1[$r]=();
                $htyp2[$r]=();
            }
        }
        
    }
    return $returnhaplotype;
}

sub haplotype_count{
    my(@haplotype)=@_;
    %temp=();
    foreach (@haplotype){
        $temp{$_}=1;
    }
    @uniquehaplotype=keys %temp;
    $number=@uniquehaplotype;
    return $number;
}

sub statejudge{
    my($sitea,$siteb)=@_;
    if($sitea eq $siteb){
        return $sitea;
    }elsif(($sitea eq 'A') && ($siteb eq 'G')){
        return "R";
    }elsif(($sitea eq 'G') && ($siteb eq 'A')){
        return "R";
    }elsif(($sitea eq 'A') && ($siteb eq 'C')){
        return 'M';
    }elsif(($sitea eq 'C') && ($siteb eq 'A')){
        return 'M';
    }elsif(($sitea eq 'A') && ($siteb eq 'T')){
        return 'W';
    }elsif(($sitea eq 'T') && ($siteb eq 'A')){
        return 'W';
    }elsif(($sitea eq 'C') && ($siteb eq 'G')){
        return 'S';
    }elsif(($sitea eq 'G') && ($siteb eq 'C')){
        return 'S';
    }elsif(($sitea eq 'C') && ($siteb eq 'T')){
        return 'Y';
    }elsif(($sitea eq 'T') && ($siteb eq 'C')){
        return 'Y';
    }elsif(($sitea eq 'G') && ($siteb eq 'T')){
        return 'K';
    }elsif(($sitea eq 'T') && ($siteb eq 'G')){
        return 'K';
    }
}