package alun.gchap;

import alun.linkage.LinkageDataSet;

/**
 This class just has a main method in it to run the 
 gene counting program.
*/
public class GCHap
{
/**
 Reads in the Linkage .par and .ped files and runs
 the gene count application.
*/
	public static void main(String[] args)
	{
		try
		{
			LinkageDataSet L = null;

			switch(args.length)
			{
			case 2:
				L = new LinkageDataSet(args[0],args[1]);
				break;
			default:
				System.err.println("Usage: java GCHap parfile pedfile");
				System.exit(1);
			}

			MarkerObservation[] x = new MarkerObservation[L.getParameterData().nLoci()];
			for (int i=0; i<x.length; i++)
			{
				x[i] = new MarkerObservation(L,i);
				System.err.println("Marker "+i+"  number of alleles = "+x[i].getTrait().getLocus().nAlleles());
			}

			Observation y = x[0];
			for (int i=1; i<x.length; i++)
			{
				System.err.print("Adding marker "+i);
				y = new MultiLocusObservation(y,x[i]);
				System.err.println(" number of haplotypes = "+y.getTrait().getLocus().nAlleles());
			}

			int its = y.geneCountToConvergence();
			y.getTrait().downCode();

			System.err.println("Log likelihood = "+y.logLikelihood()+" after "+its+" iterations");

			its = y.geneCountToConvergence();
			y.getTrait().downCode();

			System.err.println("Log likelihood = "+y.logLikelihood()+" after "+its+" iterations");

			System.out.println(HapFormatter.formatHaplotypes(y));
			System.out.println(HapFormatter.formatGuesses(y,L.getPedigreeData().getIndividuals()));
		}
		catch (Exception e)
		{
			System.err.println("Caught in GCHap:main()");
			e.printStackTrace();
		}
	}
}
