print "  \n**********CVhaplot2.0**********\n";
print     "*    Coded by Zu-Shi Huang    *\n";
print     "*    Institute of Zoology     *\n";
print     "* Chinese Academy of Sciences *\n";
print     "*     huangzs\@ioz.ac.cn       *\n";
print     "*******************************\n\n";

use Cwd;
$homedirectory=cwd;
mkdir "consistencyresult", 0775;
chdir "consistencyresult" or die "cannot chdir to consistencyresult:$!";
$CVfile="Consistency.txt";
$pairwisecompare="pairwise.txt";
open (CV, ">$CVfile");
open (PAIRWISE, ">$pairwisecompare");

#consistency examination of PHASE;
opendir (PHASE1, "$homedirectory/softwareresults/phase");
@files=grep(!/^\.\.?$/,readdir PHASE1);
closedir(PHASE1);
@files=sort (@files);
$filenumber=(@files);
if($filenumber==2){
    print "Only one solution in $homedirectory/softwareresults/phase";
}
elsif($filenumber>2){
    printf CV "############################Consistency test of PHASE########################################\n";
    $low_frequency_sum=0;
    for($k=0;$k<$filenumber;$k=$k+2){
        my(@PHASEpairs,@PHASE_haplotype_pair_probability,@PHASEcompare);
        @PHASEpairs=();
        @PHASE_haplotype_pair_probability=();
        open(PHASEPAIR,"$homedirectory/softwareresults/phase/$files[$k+1]");
        $sample_count=-1;
        $j=0;
        while(<PHASEPAIR>){
            $temp=$_;
            if($temp=~/#/){
                $j=0;
                $sample_count++;
                @PHASEcompare=();
            }elsif($temp=~/./){
                $temp=~s/\s//g;
                $site_number=index($temp,',');
                $keep_site=2*$site_number+2;
                $PHASEcompare[$j]=substr($temp,$keep_site,5);
                @PHASEcompare=reverse sort(@PHASEcompare);
                $PHASE_haplotype_pair_probability[$sample_count]=$PHASEcompare[0];
                $j++;
            }
        }
        close PHASEPAIR;

        $PHASE_number_low_frequency=0;
        for($i=0;$i<$sample_count;$i++){
            if($PHASE_haplotype_pair_probability[$i]<0.95){
                $PHASE_number_low_frequency++;
            }
        }
        $low_frequency_sum+=$PHASE_number_low_frequency;
        $low_frequency[$k]=$PHASE_number_low_frequency;
    }
    printf CV "\n";
    $namelength=length($files[0]);
    for($i=0;$i<2*$namelength+6;$i++){
        printf CV " ";
    }
    printf CV "HID            IRD\n";
    $unihaplotypesum=0;
    $comparisoncount=0;
    $y=0;
    for($k=0;$k<$filenumber;$k=$k+2){
        my(@PHASE,@PHASE_haplotype,@PHASE_individual_haplotype1,@PHASE_individual_haplotype2);
        open(PHASE,"$homedirectory/softwareresults/phase/$files[$k]");
        @PHASE_haplotype=();
        @PHASE_individual_haplotype1=();
        @PHASE_individual_haplotype2=();
        $j=0;
        $sample_count=0;
        while(<PHASE>){
            $temp=$_;
            if($temp=~/Number of Individuals/){
                $sample_number=substr($temp,23,10);
                $sample_number=~s/\s//g;
            }elsif($temp=~/Number of Loci/){
                $site_number=substr($temp,16,10);
                $site_number=~s/\s//g;
            }elsif($temp=~/.000000/){
                $PHASE_haplotype_count[$j]=substr($temp,0,10);
                $PHASE_haplotype_count[$j]=~s/\s//g;
                $temp=substr($temp,11,2*$site_number);
                $temp=~s/1 /1/g;
                $temp=~s/2 /2/g;
                $temp=~s/3 /3/g;
                $temp=~s/4 /4/g;
                $PHASE_haplotype[$j]=substr($temp,0,$site_number);
                $PHASE_haplotype[$j]=~tr/1234/ACGT/;
                $j++;
            }elsif($temp=~/#\S*:/){
                $left=index($temp,"#");
                $right=index($temp,":");
                $sample_name[$sample_count]=substr($temp,$left+1,$right-$left-1);
                $length=length($temp);
                $position=index($temp,"(");
                $position++;
                $temp=substr($temp,$position,$length);
                $position=index($temp,")");
                $temp=substr($temp,0,$position);
                $position1=index($temp,",");
                $haplotype1=substr($temp,0,$position1);
                $haplotype1--;
                $PHASE_individual_haplotype1[$sample_count]=$PHASE_haplotype[$haplotype1];
                $position1++;
                $temp=substr($temp,$position1,$length);
                $length=length($temp);
                $haplotype2=substr($temp,0,$length);
                $haplotype2--;
                $PHASE_individual_haplotype2[$sample_count]=$PHASE_haplotype[$haplotype2];
                $sample_count++;
            }
        }
        close PHASE;
        @unihty=&haplotype_count(@PHASE_individual_haplotype1,@PHASE_individual_haplotype2);
        $uniquehty[$k]=(@unihty);
        $unihaplotypesum+=$uniquehty[$k];
        for($h=$k+2;$h<$filenumber;$h=$h+2){
            my(@PHASEcompare,@PHASEcompare_haplotype,@PHASEcompare_individual_haplotype1,@PHASEcompare_individual_haplotype2);
            open(PHASECOMPARE,"$homedirectory/softwareresults/phase/$files[$h]");
            @PHASEcompare_haplotype=();
            @PHASEcompare_individual_haplotype1=();
            @PHASEcompare_individual_haplotype2=();
            $j=0;
            $sample_count=0;
            while(<PHASECOMPARE>){
                $temp=$_;
                if($temp=~/Number of Individuals/){
                    $sample_number=substr($temp,23,10);
                    $sample_number=~s/\s//g;
                }elsif($temp=~/Number of Loci/){
                    $site_number=substr($temp,16,10);
                    $site_number=~s/\s//g;
                }elsif($temp=~/.000000/){
                    $PHASEcompare_haplotype_count[$j]=substr($temp,0,10);
                    $PHASEcompare_haplotype_count[$j]=~s/\s//g;
                    $temp=substr($temp,11,2*$site_number);
                    $temp=~s/1 /1/g;
                    $temp=~s/2 /2/g;
                    $temp=~s/3 /3/g;
                    $temp=~s/4 /4/g;
                    $PHASEcompare_haplotype[$j]=substr($temp,0,$site_number);
                    $PHASEcompare_haplotype[$j]=~tr/1234/ACGT/;
                    $j++;
                }elsif($temp=~/#\S*:/){
                    $left=index($temp,"#");
                    $right=index($temp,":");
                    $sample_name[$sample_count]=substr($temp,$left+1,$right-$left-1);
                    $length=length($temp);
                    $position=index($temp,"(");
                    $position++;
                    $temp=substr($temp,$position,$length);
                    $position=index($temp,")");
                    $temp=substr($temp,0,$position);
                    $position1=index($temp,",");
                    $haplotype1=substr($temp,0,$position1);
                    $haplotype1--;
                    $PHASEcompare_individual_haplotype1[$sample_count]=$PHASEcompare_haplotype[$haplotype1];
                    $position1++;
                    $temp=substr($temp,$position1,$length);
                    $length=length($temp);
                    $haplotype2=substr($temp,0,$length);
                    $haplotype2--;
                    $PHASEcompare_individual_haplotype2[$sample_count]=$PHASEcompare_haplotype[$haplotype2];
                    $sample_count++;
                }
            }
            close PHASECOMPARE;
            @unihtycompare=&haplotype_count(@PHASEcompare_individual_haplotype1,@PHASEcompare_individual_haplotype2);
            $uniquehtycompare=(@unihtycompare);
            $comparisoncount++;
            $haplotype_inferring_count=0;
            for($m=0;$m<$uniquehty[$k];$m++){
                for($n=0;$n<$uniquehtycompare;$n++){
                    if($unihty[$m] eq $unihtycompare[$n]){
                        $haplotype_inferring_count++;
                    }
                }
            }
            $hid[$y]=1-2*$haplotype_inferring_count/($uniquehty[$k] + $uniquehtycompare);
            $sumhid+=$hid[$y];
            printf CV $files[$k]."-".$files[$h].":    ";
            printf CV ("%-0.8s",$hid[$y]);
            if($hid[$y]==0){
                printf CV "       ";
            }
            printf CV "       ";
            $individual_resolving_count=0;
            for($u=0;$u<$sample_count;$u++){
                if(($PHASE_individual_haplotype1[$u] eq $PHASEcompare_individual_haplotype1[$u]) || ($PHASE_individual_haplotype1[$u] eq $PHASEcompare_individual_haplotype2[$u])){
                    $individual_resolving_count++;
                    }
                else{$z=0;
                        $z=1+$u;
                        printf PAIRWISE $files[$k]."-".$files[$h].":  Individual $z resolved differently.\n";}
                }
            $ird[$y]=1-$individual_resolving_count/$sample_count;
            $sumird+=$ird[$y];
            printf CV ("%-0.8s\n",$ird[$y]);
            $y++;
        }
    }
    for($i=1;$i<$filenumber/2;$i++){
        $sum+=$i;
    }
    $meanhid=$sumhid/$sum;
    $hidstdsum=0;
    for($i=0;$i<$sum;$i++){
        $hidsquare=$meanhid-$hid[$i];
        $hidsquare=$hidsquare**2;
        $hidstdsum+=$hidsquare;
    }
    $hidstdsum=$hidstdsum/($sum-1);
    $hidstd=sqrt($hidstdsum);
    $meanird=$sumird/$sum;
    $irdstdsum=0;
    for($i=0;$i<$sum;$i++){
        $irdsquare=$meanird-$ird[$i];
        $irdsquare=$irdsquare**2;
        $irdstdsum+=$irdsquare;
    }
    $irdstdsum=$irdstdsum/($sum-1);
    $irdstd=sqrt($irdstdsum);
    printf CV "Mean value(STD): ";
    printf CV ("%-0.8s",$meanhid);
    printf CV "(";
    printf CV ("%-0.8s",$hidstd);
    printf CV ")       ";
    printf CV ("%-0.8s",$meanird);
    printf CV "(";
    printf CV ("%-0.8s",$irdstd);
    printf CV ")\n";
    printf CV "\n";
    for($i=0;$i<$namelength+4;$i++){
        printf CV " ";
    }
    printf CV "NLCP   NDH(Excluding the non-primary solutions)\n";
    for($k=0;$k<$filenumber;$k=$k+2){
        printf CV $files[$k].":   ".$low_frequency[$k]."     ".$uniquehty[$k]."\n";
    }
    $meanlow_frequency_sum=2*$low_frequency_sum/$filenumber;
    $meanunihaplotypesum=2*$unihaplotypesum/$filenumber;
    printf CV "mean value:   ".$meanlow_frequency_sum."   ".$meanunihaplotypesum."\n";
    printf CV "####################################################################\n";
    print "The consistency test of PHASE has been finished\n";
}

#consistency examination of ARLEQUINEM;
opendir (ARLEQUINEM, "$homedirectory/softwareresults/arlequin");
@arlefiles=grep(!/^\.\.?$/,readdir ARLEQUINEM);
closedir(ARLEQUINEM);
$arlefilenumber=(@arlefiles);
if($arlefilenumber==1){
    print "Only one solution in $homedirectory/softwareresults/arlequin";
}
elsif($arlefilenumber>1){
    $comparisoncount=0;
    printf CV "\n############################Consistency test of Arlequin-EM########################################\n";
    printf CV "\n";
    $namelength=length($arlefiles[0]);
    for($i=0;$i<2*$namelength+6;$i++){
        printf CV " ";
    }
    printf CV "HID            IRD\n";
    $low_frequency_sum=0;
    $unihaplotypesum=0;
    $y=0;
  for($k=0;$k<$arlefilenumber;$k++){
    my(@ARLEQUINEM,@ARLEQUINEM_haplotype,@ARLEQUINEM_haplotype_pair_probability,@ARLEQUINEM_individual_haplotype1,@ARLEQUINEM_individual_haplotype2);
    open(ARLEQUINEMQ,"$homedirectory/softwareresults/arlequin/$arlefiles[$k]");
    @ARLEQUINEM_haplotype=();
    @ARLEQUINEM_individual_haplotype1=();
    @ARLEQUINEM_individual_haplotype2=();
    $j=0;
    $sample_count=0;
    while(<ARLEQUINEMQ>){
        $temp=$_;
        if($temp=~/UNKNOWN/){
            $length1=length($temp);
            $temp1=substr($temp,20,$length1);
            $ARLEQUINEM_haplotype[$j]=$temp1;
            $ARLEQUINEM_haplotype[$j]=~s/\s//g;
            $ARLEQUINEM_haplotype[$j]=~s/\.//g;
            $ARLEQUINEM_haplotype[$j]=~s/\d//g;
            $j++;
        }
        elsif($temp=~/Phenotype #/){
            $t=0;
        }
        elsif($temp=~/1\s*[0-9].[0-9]*\s*0./ && $t==8){
            $position=index($temp,'.');
            $ARLEQUINEM_haplotype_pair_probability[$sample_count]=substr($temp,$position-1,8);
            $haplotype1=substr($temp,40,6);
            $haplotype1=~s/\s//g;
            $haplotype1--;
            $ARLEQUINEM_individual_haplotype1[$sample_count]=$ARLEQUINEM_haplotype[$haplotype1];
            $judge=1;
            $t++;
        }
        elsif($judge!=0){
            $temp=substr($temp,40,6);
            $haplotype2=$temp;
            $haplotype2=~s/\s//g;
            $haplotype2--;
            $ARLEQUINEM_individual_haplotype2[$sample_count]=$ARLEQUINEM_haplotype[$haplotype2];
            $judge=0;
            $sample_count++;
        }
        $t++;
    }
    close ARLEQUINEMQ;
    $ARLEQUINEM_Low_frequency_count=0;
    for($i=0;$i<$sample_count;$i++){
        if($ARLEQUINEM_haplotype_pair_probability[$i]<0.95){
            $ARLEQUINEM_Low_frequency_count++;
        }
    }
    $low_frequency_count[$k]=$ARLEQUINEM_Low_frequency_count;
    $low_frequency_sum+=$low_frequency_count[$k];
    @unihty=&haplotype_count(@ARLEQUINEM_individual_haplotype1,@ARLEQUINEM_individual_haplotype2);
    $uniquehty[$k]=(@unihty);
    $unihaplotypesum+=$uniquehty[$k];
    for($h=$k+1;$h<$arlefilenumber;$h++){
        my(@ARLEQUINEMcompare,@ARLEQUINEMcompare_haplotype,@ARLEQUINEMcompare_individual_haplotype1,@ARLEQUINEMcompare_individual_haplotype2);
        open(ARLEQUINEMCOMPARE,"$homedirectory/softwareresults/arlequin/$arlefiles[$h]");
        @ARLEQUINEMcompare_haplotype=();
        @ARLEQUINEMcompare_individual_haplotype1=();
        @ARLEQUINEMcompare_individual_haplotype2=();
        $j=0;
        $sample_count=0;
        while(<ARLEQUINEMCOMPARE>){
            $temp=$_;
            if($temp=~/UNKNOWN/){
                $length1=length($temp);
                $temp1=substr($temp,20,$length1);
                $ARLEQUINEMcompare_haplotype[$j]=$temp1;
                $ARLEQUINEMcompare_haplotype[$j]=~s/\s//g;
                $ARLEQUINEMcompare_haplotype[$j]=~s/\.//g;
                $ARLEQUINEMcompare_haplotype[$j]=~s/\d//g;
                $j++;
            }
            elsif($temp=~/Phenotype #/){
                $t=0;
            }
            elsif($temp=~/1\s*[0-9].[0-9]*\s*0./ && $t==8){
                $haplotype1=substr($temp,40,6);
                $haplotype1=~s/\s//g;
                $haplotype1--;
                $ARLEQUINEMcompare_individual_haplotype1[$sample_count]=$ARLEQUINEMcompare_haplotype[$haplotype1];
                $judge=1;
                $t++;
            }
            elsif($judge!=0){
                $temp=substr($temp,40,6);
                $haplotype2=$temp;
                $haplotype2=~s/\s//g;
                $haplotype2--;
                $ARLEQUINEMcompare_individual_haplotype2[$sample_count]=$ARLEQUINEMcompare_haplotype[$haplotype2];
                $judge=0;
                $sample_count++;
            }
            $t++;
        }
        close ARLEQUINEMCOMPARE;
        @unihtycompare=&haplotype_count(@ARLEQUINEMcompare_individual_haplotype1,@ARLEQUINEMcompare_individual_haplotype2);
        $uniquehtycompare=(@unihtycompare);
        $comparisoncount++;
        $haplotype_inferring_count=0;
        for($m=0;$m<$uniquehty[$k];$m++){
            for($n=0;$n<$uniquehtycompare;$n++){
                if($unihty[$m] eq $unihtycompare[$n]){
                    $haplotype_inferring_count++;
                }
            }
        }
        $arlehid[$y]=1-2*$haplotype_inferring_count/($uniquehty[$k] + $uniquehtycompare);
        $arlesumhid+=$arlehid[$y];
        printf CV $arlefiles[$k]."-".$arlefiles[$h].":    ";
        printf CV ("%-0.8s",$arlehid[$y]);
        if($arlehid[$y]==0){
                printf CV "       ";
            }
        printf CV "       ";
        $individual_resolving_count=0;
        for($u=0;$u<$sample_count;$u++){
            if(($ARLEQUINEM_individual_haplotype1[$u] eq $ARLEQUINEMcompare_individual_haplotype1[$u]) || ($ARLEQUINEM_individual_haplotype1[$u] eq $ARLEQUINEMcompare_individual_haplotype2[$u])){
                $individual_resolving_count++;
               }
            else{$z=0;
                    $z=1+$u;
                    printf PAIRWISE $arlefiles[$k]."-".$arlefiles[$h].":  Individual $z resolved differently\n";}
        }
        $arleird[$y]=1-$individual_resolving_count/$sample_count;
        $arlesumird+=$arleird[$y];
        printf CV ("%-0.8s\n",$arleird[$y]);
        $y++;
    }

  }
    for($i=1;$i<$arlefilenumber;$i++){
       $arlesum+=$i;
    }
    $meanhid=$arlesumhid/$arlesum;
    $hidstdsum=0;
    for($i=0;$i<$arlesum;$i++){
        $hidsquare=$meanhid-$arlehid[$i];
        $hidsquare=$hidsquare**2;
        $hidstdsum+=$hidsquare;
    }
    $hidstdsum=$hidstdsum/($arlesum-1);
    $hidstd=sqrt($hidstdsum);
    $meanird=$arlesumird/$arlesum;
    $irdstdsum=0;
    for($i=0;$i<$arlesum;$i++){
        $irdsquare=$meanird-$arleird[$i];
        $irdsquare=$irdsquare**2;
        $irdstdsum+=$irdsquare;
    }
    $irdstdsum=$irdstdsum/($arlesum-1);
    $irdstd=sqrt($irdstdsum);
    printf CV "Mean value(STD): ";
    printf CV ("%-0.8s",$meanhid);
    printf CV "(";
    printf CV ("%-0.8s",$hidstd);
    printf CV ")       ";
    printf CV ("%-0.8s",$meanird);
    printf CV "(";
    printf CV ("%-0.8s",$irdstd);
    printf CV ")\n";
    printf CV "\n";
    for($i=0;$i<$namelength+4;$i++){
        printf CV " ";
    }
    printf CV "NLCP   NDH(Excluding the non-primary solutions)\n";
    for($k=0;$k<$arlefilenumber;$k++){
        printf CV $arlefiles[$k].":   ".$low_frequency_count[$k]."      ".$uniquehty[$k]."\n";
    }
    $meanlow_frequency_sum=$low_frequency_sum/$arlefilenumber;
    $meanunihaplotypesum=$unihaplotypesum/$arlefilenumber;
    printf CV "mean value:   ".$meanlow_frequency_sum."     ".$meanunihaplotypesum."\n";
    printf CV "####################################################################\n";
    print "The consistency test of Arlequin-EM has been finished\n";
}


#consistency examination of HAPLOREC;
opendir (HAPLOREC, "$homedirectory/softwareresults/haplorec");
@haplorecfiles=grep(!/^\.\.?$/,readdir HAPLOREC);
closedir(HAPLOREC);
$haplorecfilenumber=(@haplorecfiles);
if($haplorecfilenumber==1){
    print "Only one solution in $homedirectory/softwareresults/haplorec";
}
elsif($haplorecfilenumber>1){
    printf CV "\n############################Consistency test of HaploRec########################################\n";
    printf CV "\n";
    $namelength=length($haplorecfiles[0]);
    for($i=0;$i<2*$namelength+6;$i++){
        printf CV " ";
    }
    printf CV "HID            IRD\n";
    $haplorec_low_frequency_sum=0;
    $haplorecunihaplotypesum=0;
    $comparisoncount=0;
    $y=0;
    for($k=0;$k<$haplorecfilenumber;$k++){
        my(@HaploRec,@HaploRec_haplotype,@HaploRec_haplotype_pair_probability,@HaploRec_individual_haplotype1,@HaploRec_individual_haplotype2);
        open(HAPLORECQ,"$homedirectory/softwareresults/haplorec/$haplorecfiles[$k]");
        @HaploRec_haplotype=();
        @HaploRec_individual_haplotype1=();
        @HaploRec_individual_haplotype2=();
        $j=0;
        $sample_count=0;
        while(<HAPLORECQ>){
            $temp=$_;
            if($temp=~/Id/){
                $position=index($temp,'CONFIDENCE');
                $temp=substr($temp,3,$position-3);
                $temp=~s/[0-9]*\s/A/g;
                $site_number=length($temp);
                $j=1;
            }
            elsif($j!=0){
                $position=index($temp,' ');
                $position1=index($temp,'-');
                $temp1=substr($temp,$position+1,2*$site_number);
                $frequency=$position1-$position-2*$site_number-2;
                $HaploRec_haplotype_pair_probability[$sample_count]=substr($temp,$position+1+2*$site_number,$frequency);
                $temp1=~s/\s//g;
                $temp1=~tr/1234/ACGT/;
                $HaploRec_individual_haplotype1[$sample_count]=$temp1;
                $j=0;
                $judge=1;
            }
            elsif($judge==1){
                $temp=substr($temp,$position+1,2*$site_number);
                $temp=~s/\s//g;
                $temp=~tr/1234/ACGT/;
                $HaploRec_individual_haplotype2[$sample_count]=$temp;
                $j=1;
                $judge=0;
                $sample_count++;
            }
        }
        close HAPLORECQ;
        $HaploRec_Low_frequency_count=0;
        for($i=0;$i<$sample_count;$i++){
            if($HaploRec_haplotype_pair_probability[$i]<0.5 && $HaploRec_haplotype_pair_probability[$i]!=0){
                $HaploRec_Low_frequency_count++;
            }
        }
        $haplorec_low_frequency_count[$k]=$HaploRec_Low_frequency_count;
        $haplorec_low_frequency_sum+=$haplorec_low_frequency_count[$k];
        @haplorecunihty=&haplotype_count(@HaploRec_individual_haplotype1,@HaploRec_individual_haplotype2);
        $haplorecuniquehty[$k]=(@haplorecunihty);
        $haplorecunihaplotypesum+=$haplorecuniquehty[$k];
        for($h=$k+1;$h<$haplorecfilenumber;$h++){
            my(@HaploReccompare,@HaploReccompare_haplotype,@HaploReccompare_individual_haplotype1,@HaploReccompare_individual_haplotype2);
            open(HAPLORECCOMPARE,"$homedirectory/softwareresults/haplorec/$haplorecfiles[$h]");
            @HaploReccompare_haplotype=();
            @HaploReccompare_individual_haplotype1=();
            @HaploReccompare_individual_haplotype2=();
            $j=0;
            $sample_count=0;
            while(<HAPLORECCOMPARE>){
                $temp=$_;
                if($temp=~/Id/){
                    $position=index($temp,'CONFIDENCE');
                    $temp=substr($temp,3,$position-3);
                    $temp=~s/[0-9]*\s/A/g;
                    $site_number=length($temp);
                    $j=1;
                }
                elsif($j!=0){
                    $position=index($temp,' ');
                    $position1=index($temp,'-');
                    $temp1=substr($temp,$position+1,2*$site_number);
                    $temp1=~s/\s//g;
                    $temp1=~tr/1234/ACGT/;
                    $HaploReccompare_individual_haplotype1[$sample_count]=$temp1;
                    $j=0;
                    $judge=1;
                }
                elsif($judge==1){
                    $temp=substr($temp,$position+1,2*$site_number);
                    $temp=~s/\s//g;
                    $temp=~tr/1234/ACGT/;
                    $HaploReccompare_individual_haplotype2[$sample_count]=$temp;
                    $j=1;
                    $judge=0;
                    $sample_count++;
                }
            }
            close HAPLORECCOMPARE;
            @HaploRecunihtycompare=&haplotype_count(@HaploReccompare_individual_haplotype1,@HaploReccompare_individual_haplotype2);
            $HaploRecuniquehtycompare=(@HaploRecunihtycompare);
            $comparisoncount++;
            $haplotype_inferring_count=0;
            for($m=0;$m<$haplorecuniquehty[$k];$m++){
                for($n=0;$n<$HaploRecuniquehtycompare;$n++){
                    if($haplorecunihty[$m] eq $HaploRecunihtycompare[$n]){
                        $haplotype_inferring_count++;
                    }
                }
            }
            $haplorechid[$y]=1-2*$haplotype_inferring_count/($haplorecuniquehty[$k] + $HaploRecuniquehtycompare);
            $haplorecsumhid+=$haplorechid[$y];
            printf CV $haplorecfiles[$k]."-".$haplorecfiles[$h].":    ";
            printf CV ("%-0.8s",$haplorechid[$y]);
            if($haplorechid[$y]==0){
                printf CV "       ";
            }
            printf CV "       ";
            $individual_resolving_count=0;
            for($u=0;$u<$sample_count;$u++){
                if(($HaploRec_individual_haplotype1[$u] eq $HaploReccompare_individual_haplotype1[$u]) || ($HaploRec_individual_haplotype1[$u] eq $HaploReccompare_individual_haplotype2[$u])){
                    $individual_resolving_count++;
                }
                else{$z=0;
                    $z=1+$u;
                    printf PAIRWISE $haplorecfiles[$k]."-".$haplorecfiles[$h].":  Individual $z resolved differently.\n";}
            }
            $haplorecird[$y]=1-$individual_resolving_count/$sample_count;
            $haplorecsumird+=$haplorecird[$y];
            printf CV ("%-0.8s\n",$haplorecird[$y]);
            $y++;
        }
    }
    for($i=1;$i<$haplorecfilenumber;$i++){
       $haplorecsum+=$i;
    }
    $meanhid=$haplorecsumhid/$haplorecsum;
    $hidstdsum=0;
    for($i=0;$i<$haplorecsum;$i++){
        $hidsquare=$meanhid-$haplorechid[$i];
        $hidsquare=$hidsquare**2;
        $hidstdsum+=$hidsquare;
    }
    $hidstdsum=$hidstdsum/($haplorecsum-1);
    $hidstd=sqrt($hidstdsum);
    $meanird=$haplorecsumird/$haplorecsum;
    $irdstdsum=0;
    for($i=0;$i<$haplorecsum;$i++){
        $irdsquare=$meanird-$haplorecird[$i];
        $irdsquare=$irdsquare**2;
        $irdstdsum+=$irdsquare;
    }
    $irdstdsum=$irdstdsum/($haplorecsum-1);
    $irdstd=sqrt($irdstdsum);
    printf CV "Mean value(STD): ";
    printf CV ("%-0.8s",$meanhid);
    printf CV "(";
    printf CV ("%-0.8s",$hidstd);
    printf CV ")       ";
    printf CV ("%-0.8s",$meanird);
    printf CV "(";
    printf CV ("%-0.8s",$irdstd);
    printf CV ")\n";
    printf CV "\n";
    for($i=0;$i<$namelength+4;$i++){
        printf CV " ";
    }
    printf CV "NLCP  NDH(Excluding the non-primary solutions)\n";
    for($k=0;$k<$haplorecfilenumber;$k++){
        printf CV $haplorecfiles[$k].":   ".$haplorec_low_frequency_count[$k]."     ".$haplorecuniquehty[$k]."\n";
    }
    $meanhaploreclow_frequency_sum=$haplorec_low_frequency_sum/$haplorecfilenumber;
    $meanhaplorecunihaplotypesum=$haplorecunihaplotypesum/$haplorecfilenumber;
    printf CV "mean value:   ".$meanhaploreclow_frequency_sum."   ".$meanhaplorecunihaplotypesum."\n";
    printf CV "####################################################################\n";
    print "The consistency test of HaploRec has been finished\n";
}


#consistency examination of HAPLOTYPER;
opendir (HAPLOTYPER, "$homedirectory/softwareresults/haplotyper");
@Haplotyperfiles=grep(!/^\.\.?$/,readdir HAPLOTYPER);
closedir(HAPLOTYPER);
$Haplotyperfilenumber=(@Haplotyperfiles);
if($Haplotyperfilenumber==1){
    print "Only one solution in $homedirectory/softwareresults/haplotyper";
}
elsif($Haplotyperfilenumber>1){
    open (CHARACTER,"$homedirectory/transfile/character.txt") ||die "Cannot open character.txt: $!\n";
    my(@first_base,@second_base,@third_base);
    @character=<CHARACTER>;
    $site_number=(@character);
    $i=0;
    for($g=0;$g<$site_number;$g++){
        $temp=$character[$g];
        $temp=~s/\W+//g;
        $temp=~s/\d+//g;
        $nucleotednumber=length($temp);
        if($nucleotednumber==2){
                $first_base[$i]=substr($temp,0,1);
                $second_base[$i]=substr($temp,1,1);
                $third_base[$i]=" ";
                $i++;
        }elsif($nucleotednumber==3){
                $first_base[$i]=substr($temp,0,1);
                $second_base[$i]=substr($temp,1,1);
                $third_base[$i]=substr($temp,2,1);
                $i++;
        }
    }
    $site_number=$i;
    close CHARACTER;
    printf CV "\n############################Consistency test of HAPLOTYPER########################################\n";
    printf CV "\n";
    $namelength=length($Haplotyperfiles[0]);
    for($i=0;$i<2*$namelength+6;$i++){
        printf CV " ";
    }
    printf CV "HID            IRD\n";
    $comparisoncount=0;
    $Haplotyper_low_frequency_sum=0;
    $Haplotyperunihaplotypesum=0;
    $y=0;
    $computation=0;
    for($t=0;$t<$Haplotyperfilenumber;$t++){
        $computation+=$t;
    }
    $computationtotal=$computation;
    $computation/=10;
    $computation1=$computation;
    for($k=0;$k<$Haplotyperfilenumber;$k++){
        my(@Haplotyper,@Haplotyper_haplotype_pair_probability,@Haplotyper_individual_haplotype1,@Haplotyper_individual_haplotype2);
        open(HAPLOTYPERQ,"$homedirectory/softwareresults/haplotyper/$Haplotyperfiles[$k]");
        @Haplotyper_individual_haplotype1=();
        @Haplotyper_individual_haplotype2=();
        @Haplotyper_haplotype_pair_probability=();
        $j=0;
        $sample_count=0;
        while(<HAPLOTYPERQ>){
            $temp=$_;
            if($temp=~/---/){
                $position=index($temp,'.');
                $Haplotyper_haplotype_pair_probability[$sample_count]=substr($temp,$position-1,7);
                $judge=1;
            }
            elsif($judge==1){
                for($j=0;$j<$site_number;$j++){
                    $transition=&tri_transHAPLOTYPER($first_base[$j],$second_base[$j],$third_base[$j],$temp,$j,$sample_count,$Haplotyperfiles[$k]);
                    $temp=$transition;
                }
                chomp($temp);
                $Haplotyper_individual_haplotype1[$sample_count]=$temp;
                $judge++;
            }
            elsif($judge==2){
                for($j=0;$j<$site_number;$j++){
                    $transition=&tri_transHAPLOTYPER($first_base[$j],$second_base[$j],$third_base[$j],$temp,$j,$sample_count,$Haplotyperfiles[$k]);
                    $temp=$transition;
                }
                chomp($temp);
                $Haplotyper_individual_haplotype2[$sample_count]=$temp;
                $judge=0;
                $sample_count++;
            }
        }
        close HAPLOTYPERQ;
        $haplotyper_low_frequency_count=0;
        for($t=0;$t<$sample_count;$t++){
            if($Haplotyper_haplotype_pair_probability[$t]<0.95){

                $haplotyper_low_frequency_count++;
            }
        }
        $Haplotyper_low_frequency_count[$k]=$haplotyper_low_frequency_count;
        $Haplotyper_low_frequency_sum+=$Haplotyper_low_frequency_count[$k];
        @Haplotyperunihty=&haplotype_count(@Haplotyper_individual_haplotype1,@Haplotyper_individual_haplotype2);
        $Haplotyperuniquehty[$k]=(@Haplotyperunihty);
        $Haplotyperunihaplotypesum+=$Haplotyperuniquehty[$k];
        for($h=$k+1;$h<$Haplotyperfilenumber;$h++){
            my(@Haplotypercompare,@Haplotypercompare_individual_haplotype1,@Haplotypercompare_individual_haplotype2);
            open(HAPLOTYPERCOMPARE,"$homedirectory/softwareresults/haplotyper/$Haplotyperfiles[$h]");
            @Haplotypercompare_individual_haplotype1=();
            @Haplotypercompare_individual_haplotype2=();
            $j=0;
            $sample_count=0;
            while(<HAPLOTYPERCOMPARE>){
                $temp=$_;
                if($temp=~/---/){
                    $judge=1;
                }
                elsif($judge==1){
                    for($j=0;$j<$site_number;$j++){
                        $transition=&tri_transHAPLOTYPER2($first_base[$j],$second_base[$j],$third_base[$j],$temp,$j,$sample_count);
                        $temp=$transition;
                    }
                    chomp($temp);
                    $Haplotypercompare_individual_haplotype1[$sample_count]=$temp;
                    $judge++;
                }
                elsif($judge==2){
                    for($j=0;$j<$site_number;$j++){
                        $transition=&tri_transHAPLOTYPER2($first_base[$j],$second_base[$j],$third_base[$j],$temp,$j,$sample_count);
                        $temp=$transition;
                    }
                    chomp($temp);
                    $Haplotypercompare_individual_haplotype2[$sample_count]=$temp;
                    $judge=0;
                    $sample_count++;
                }
            }
            close HAPLOTYPERCOMPARE;
            @Haplotyperunihtycompare=&haplotype_count(@Haplotypercompare_individual_haplotype1,@Haplotypercompare_individual_haplotype2);
            $Haplotyperuniquehtycompare=(@Haplotyperunihtycompare);
            $comparisoncount++;
            if($comparisoncount>$computation){
                $percent=$computation/$computationtotal;
                $percent*=100;
                print "Please Wait!    I have finished $percent% of consistency test of HAPLOTYPER!!!\n";
                $computation+=$computation1;
            }
            $haplotype_inferring_count=0;
            for($m=0;$m<$Haplotyperuniquehty[$k];$m++){
                for($n=0;$n<$Haplotyperuniquehtycompare;$n++){
                    if($Haplotyperunihty[$m] eq $Haplotyperunihtycompare[$n]){
                        $haplotype_inferring_count++;
                    }
                }
            }
            $Haplotyperhid[$y]=1-2*$haplotype_inferring_count/($Haplotyperuniquehty[$k] + $Haplotyperuniquehtycompare);
            $Haplotypersumhid+=$Haplotyperhid[$y];
            printf CV $Haplotyperfiles[$k]."-".$Haplotyperfiles[$h].":    ";
            printf CV ("%-0.8s",$Haplotyperhid[$y]);
            if($Haplotyperhid[$y]==0){
                printf CV "       ";
            }
            printf CV "       ";
            $individual_resolving_count=0;
            for($u=0;$u<$sample_count;$u++){
                if(($Haplotyper_individual_haplotype1[$u] eq $Haplotypercompare_individual_haplotype1[$u]) || ($Haplotyper_individual_haplotype1[$u] eq $Haplotypercompare_individual_haplotype2[$u])){
                    $individual_resolving_count++;
                }
                else{$z=0;
                    $z=1+$u;
                    printf PAIRWISE $Haplotyperfiles[$k]."-".$Haplotyperfiles[$h].":  Individual $z resolved differently.\n";}
            }
            $Haplotyperird[$y]=1-$individual_resolving_count/$sample_count;
            $Haplotypersumird+=$Haplotyperird[$y];
            printf CV ("%-0.8s\n",$Haplotyperird[$y]);
            $y++;
        }
    }
    for($i=1;$i<$Haplotyperfilenumber;$i++){
       $Haplotypersum+=$i;
    }
    $meanhid=$Haplotypersumhid/$Haplotypersum;
    $hidstdsum=0;
    for($i=0;$i<$Haplotypersum;$i++){
        $hidsquare=$meanhid-$Haplotyperhid[$i];
        $hidsquare=$hidsquare**2;
        $hidstdsum+=$hidsquare;
    }
    $hidstdsum=$hidstdsum/($Haplotypersum-1);
    $hidstd=sqrt($hidstdsum);
    $meanird=$Haplotypersumird/$Haplotypersum;
    $irdstdsum=0;
    for($i=0;$i<$Haplotypersum;$i++){
        $irdsquare=$meanird-$Haplotyperird[$i];
        $irdsquare=$irdsquare**2;
        $irdstdsum+=$irdsquare;
    }
    $irdstdsum=$irdstdsum/($Haplotypersum-1);
    $irdstd=sqrt($irdstdsum);
    printf CV "Mean value(STD): ";
    printf CV ("%-0.8s",$meanhid);
    printf CV "(";
    printf CV ("%-0.8s",$hidstd);
    printf CV ")       ";
    printf CV ("%-0.8s",$meanird);
    printf CV "(";
    printf CV ("%-0.8s",$irdstd);
    printf CV ")\n";
    printf CV "\n";
    for($i=0;$i<$namelength+4;$i++){
        printf CV " ";
    }
    printf CV "NLCP   NDH(Excluding the non-primary solutions)\n";
    for($k=0;$k<$Haplotyperfilenumber;$k++){
        printf CV $Haplotyperfiles[$k].":   ".$Haplotyper_low_frequency_count[$k]."      ".$Haplotyperuniquehty[$k]."\n";
    }
    $meanHaplotyperlow_frequency_sum=$Haplotyper_low_frequency_sum/$Haplotyperfilenumber;
    $meanHaplotyperunihaplotypesum=$Haplotyperunihaplotypesum/$Haplotyperfilenumber;
    printf CV "mean value:   ".$meanHaplotyperlow_frequency_sum."   ".$meanHaplotyperunihaplotypesum."\n";
    printf CV "####################################################################\n";
    print "The consistency test of HAPLOTYPER has been finished\n";
}

#consistency examination of HAPINFERX and selection of an ensemble of independent iterations whose NDH (number of distinct haplotypes) values are among the smallest;
opendir (HAPINFERX, "$homedirectory/softwareresults/hapinferx");
@Hapinferxfiles=grep(!/^\.\.?$/,readdir HAPINFERX);
closedir(HAPINFERX);
$Hapinferxfilenumber=(@Hapinferxfiles);
@Hapinferxfiles=(sort{$a<=>$b}@Hapinferxfiles);
@NDHminHapinferxfiles=();
$NDHmin=9999;
@abnomalsolution=();
$abnomalsolutionnumber=0;
my(%lowfreq,%haplot1,%haplot2);
if($Hapinferxfilenumber==1){
    print "Only one solution in $homedirectory/softwareresults/hapinferx";
}
elsif($Hapinferxfilenumber>1){
    printf CV "\n############################Consistency test of HAPINFERX########################################\n";
    printf CV "\n";
    $namelength=length($Hapinferxfiles[0]);
    for($i=0;$i<2*$namelength+6;$i++){
        printf CV " ";
    }
    printf CV "HID            IRD\n";
    $Hapinferx_low_frequency_sum=0;
    $Hapinferxunihaplotypesum=0;
    $comparisoncount=0;
    $y=0;
    for($k=0;$k<$Hapinferxfilenumber;$k++){
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$Hapinferxfiles[$k]");
        while(<HAPINFERXQ>){
            $temp=$_;
            if($temp=~/One mutation/){
                $abnomalsolution[$abnomalsolutionnumber]=$Hapinferxfiles[$k];
                $abnomalsolutionnumber++;
                $Hapinferxfiles[$k]=();
                last;
            }
            elsif($temp=~/Unresolved genotypes were/){
                $abnomalsolution[$abnomalsolutionnumber]=$Hapinferxfiles[$k];
                $abnomalsolutionnumber++;
                $Hapinferxfiles[$k]=();
                last;
            }
        }
    }
    @regulatefile=();
    $consisfile=0;
    for($k=0;$k<$Hapinferxfilenumber;$k++){
        if($Hapinferxfiles[$k]){
            $regulatefile[$consisfile]=$Hapinferxfiles[$k];
            $consisfile++;
        }
    }
    $Hapinferxfilenumber=$consisfile;
    @Hapinferxfiles=@regulatefile;
    $computation=0;
    for($t=0;$t<$Hapinferxfilenumber;$t++){
        $computation+=$t;
    }
    $computationtotal=$computation;
    $computation/=10;
    $computation1=$computation;
    for($k=0;$k<$Hapinferxfilenumber;$k++){
        my(@Hapinferx,@Hapinferx_haplotype,@Hapinferx_haplotype_pair_probability,%Hapinferx_individual_haplotype1,%Hapinferx_individual_haplotype2);
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$Hapinferxfiles[$k]");
        @Hapinferx=<HAPINFERXQ>;
        %Hapinferx_individual_haplotype1=();
        %Hapinferx_individual_haplotype2=();
        @Hapinferx_haplotype=();
        @Hapinferx_haplotype_pair_probability=();
        $haplotype_count=0;
        $sample_count=0;
        $skip_line=0;
        $t=0;
        $judge=0;
        $individual=0;
        $length=length($Hapinferx[1]);
        @Hapinferx=();
        close HAPINFERXQ;
        @second_solution_frequency=();
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$Hapinferxfiles[$k]");
        while(<HAPINFERXQ>){
            $temp=$_;
            if($temp=~/TITLE: Hapinfer output data/){
                $skip_line++;
            }
            elsif($temp=~/[0-9]\s:\s[A-Z]/i && $skip_line!=0){
                $temp=~s/\W+//g;
                $temp=~s/\d+//g;
                $Hapinferx_haplotype[$haplotype_count]=$temp;
                $Hapinferx_haplotype[$haplotype_count]=~s/\s//g;
                $haplotype_count++;
            }
            elsif($temp=~/number of phenotypes/){
                $judge=1;
            }
            elsif($temp=~/#/ && $judge!=0){
                $name=();
                $name=$temp;
                $name=~s/\W+//g;
                $individual=1;
                $trans=$sample_count;
                @Hapinferx_frequency_compare=();
                $solution_count=0;
            }
            elsif($temp=~/-\s[0-9]*\s1.000000/ && $individual!=0){
                $temp=~s/\D+//g;
                $length=length($temp);
                $templength1=$length-7;
                $haplotype1=substr($temp,0,$templength1);
                $haplotype1--;
                $Hapinferx_individual_haplotype1{$name}=$Hapinferx_haplotype[$haplotype1];
                $Hapinferx_individual_haplotype1{$name}=~tr/acgt/ACGT/;
                $t=1;
            }
            elsif($temp=~/-\s[0-9]*/ && $t!=0){
                $temp=~s/\D+//g;
                $haplotype2=$temp;
                $haplotype2--;
                $Hapinferx_individual_haplotype2{$name}=$Hapinferx_haplotype[$haplotype2];
                $Hapinferx_individual_haplotype2{$name}=~tr/acgt/ACGT/;
                $t=0;
                $sample_count++;
            }
            elsif($temp=~/-\s[0-9]*\s0./){
                $position=index($temp,".");
                $position--;
                $HAPINFERXcompare[$solution_count]=substr($temp,$position,8);
                @HAPINFERXcompare=reverse sort(@HAPINFERXcompare);
                $second_solution_frequency[$trans]=$HAPINFERXcompare[0];
                $second_solution_frequency[$name]=$HAPINFERXcompare[0];
                $solution_count++;
            }
        }
        close HAPINFERXQ;
        $hapinferx_low_frequent_count=0;
        for($i=0;$i<$sample_count;$i++){
            if($second_solution_frequency[$i]>0.05){
                $hapinferx_low_frequent_count++;
            }
        }
        $Hapinferx_low_frequency_count[$k]=$hapinferx_low_frequent_count;
        $Hapinferx_low_frequency_sum+=$Hapinferx_low_frequency_count[$k];
        @Hapinferx_haplotype1=values(%Hapinferx_individual_haplotype1);
        @Hapinferx_haplotype2=values(%Hapinferx_individual_haplotype2);
        @Hapinferxunihty=&haplotype_count(@Hapinferx_haplotype1,@Hapinferx_haplotype2);
        $Hapinferxuniquehty[$k]=(@Hapinferxunihty);
        if($Hapinferxuniquehty[$k]<$NDHmin) {
            $NDHmin=$Hapinferxuniquehty[$k];
        }
        $Hapinferxunihaplotypesum+=$Hapinferxuniquehty[$k];
        for($h=$k+1;$h<$Hapinferxfilenumber;$h++){
            my(@Hapinferxcompare,@Hapinferxcompare_haplotype,%Hapinferxcompare_individual_haplotype1,%Hapinferxcompare_individual_haplotype2);
            open(HAPINFERXCOMPARE,"$homedirectory/softwareresults/hapinferx/$Hapinferxfiles[$h]");
            %Hapinferxcompare_individual_haplotype1=();
            %Hapinferxcompare_individual_haplotype2=();
            @Hapinferxcompare_haplotype=();
            $haplotype_count=0;
            $sample_count=0;
            $skip_line=0;
            $t=0;
            $judge=0;
            $individual=0;
            while(<HAPINFERXCOMPARE>){
                $temp=$_;
                if($temp=~/TITLE: Hapinfer output data/){
                    $skip_line++;
                }
                elsif($temp=~/[0-9]\s:\s[A-Z]/i && $skip_line!=0){
                    $temp=~s/\W+//g;
                    $temp=~s/\d+//g;
                    $Hapinferxcompare_haplotype[$haplotype_count]=$temp;
                    $Hapinferxcompare_haplotype[$haplotype_count]=~s/\s//g;
                    $haplotype_count++;
                }
                elsif($temp=~/number of phenotypes/){
                    $judge=1;
                }
                elsif($temp=~/#/ && $judge!=0){
                    $name=();
                    $name=$temp;
                    $name=~s/\W+//g;
                    $individual=1;
                }
                elsif($temp=~/-\s[0-9]*\s1.000000/ && $individual!=0){
                    $temp=~s/\D+//g;
                    $length=length($temp);
                    $templength1=$length-7;
                    $haplotype1=substr($temp,0,$templength1);
                    $haplotype1--;
                    $Hapinferxcompare_individual_haplotype1{$name}=$Hapinferxcompare_haplotype[$haplotype1];
                    $Hapinferxcompare_individual_haplotype1{$name}=~tr/acgt/ACGT/;
                    $t=1;
                }
                elsif($temp=~/-\s[0-9]*/ && $t!=0){
                    $temp=~s/\D+//g;
                    $haplotype2=$temp;
                    $haplotype2--;
                    $Hapinferxcompare_individual_haplotype2{$name}=$Hapinferxcompare_haplotype[$haplotype2];
                    $Hapinferxcompare_individual_haplotype2{$name}=~tr/acgt/ACGT/;
                    $t=0;
                    $sample_count++;
                }
            }
            close HAPINFERXCOMPARE;
            @Hapinferxcompare_haplotype1=values(%Hapinferxcompare_individual_haplotype1);
            @Hapinferxcompare_haplotype2=values(%Hapinferxcompare_individual_haplotype2);
            @Hapinferxcompareunihty=&haplotype_count(@Hapinferxcompare_haplotype1,@Hapinferxcompare_haplotype2);
            $Hapinferxcompareuniquehty=(@Hapinferxcompareunihty);
            $comparisoncount++;
            if($comparisoncount>$computation){
                $percent=$computation/$computationtotal;
                $percent*=100;
                print "Please Wait!    I have finished $percent% of consistency test of HAPINFERX!!!\n";
                $computation+=$computation1;
            }
            $haplotype_inferring_count=0;
            for($m=0;$m<$Hapinferxuniquehty[$k];$m++){
                for($n=0;$n<$Hapinferxcompareuniquehty;$n++){
                    if($Hapinferxunihty[$m] eq $Hapinferxcompareunihty[$n]){
                        $haplotype_inferring_count++;
                    }
                }
            }
            $Hapinferxhid[$y]=1-2*$haplotype_inferring_count/($Hapinferxuniquehty[$k] + $Hapinferxcompareuniquehty);
            $Hapinferxsumhid+=$Hapinferxhid[$y];
            printf CV $Hapinferxfiles[$k]."-".$Hapinferxfiles[$h].":    ";
            printf CV ("%-0.8s",$Hapinferxhid[$y]);
            if($Hapinferxhid[$y]==0){
                printf CV "       ";
            }
            printf CV "       ";
            $individual_resolving_count=0;
            @namekey=keys(%Hapinferx_individual_haplotype1);
            $namenumber=(@namekey);
            for($u=0;$u<$namenumber;$u++){
                if(($Hapinferx_individual_haplotype1{$namekey[$u]} eq $Hapinferxcompare_individual_haplotype1{$namekey[$u]}) || ($Hapinferx_individual_haplotype1{$namekey[$u]} eq $Hapinferxcompare_individual_haplotype2{$namekey[$u]})){
                    $individual_resolving_count++;
                }
                else{
    #                $uniquekeys[$u]=$namekey[$u];
                    printf PAIRWISE $Hapinferxfiles[$k]."-".$Hapinferxfiles[$h].":  Individual $namekey[$u] resolved differently.\n";
                }
            }
            $Hapinferxird[$y]=1-$individual_resolving_count/$namenumber;
            $Hapinferxsumird+=$Hapinferxird[$y];
            printf CV ("%-0.8s\n",$Hapinferxird[$y]);
            $y++;
        }
    }
    for($i=1;$i<$Hapinferxfilenumber;$i++){
        $Hapinferxsum+=$i;
    }
    if($Hapinferxsum==0){
        print "HAPINFERX is not perform the consistency test and included in the consensus vote analysis because all HAPINFERX runs of the data set are abnormal";
        exit;
    }
    $meanhid=$Hapinferxsumhid/$Hapinferxsum;
    $hidstdsum=0;
    for($i=0;$i<$Hapinferxsum;$i++){
        $hidsquare=$meanhid-$Hapinferxhid[$i];
        $hidsquare=$hidsquare**2;
        $hidstdsum+=$hidsquare;
    }
    $hidstdsum=$hidstdsum/($Hapinferxsum-1);
    $hidstd=sqrt($hidstdsum);
    $meanird=$Hapinferxsumird/$Hapinferxsum;
    $irdstdsum=0;
    for($i=0;$i<$Hapinferxsum;$i++){
        $irdsquare=$meanird-$Hapinferxird[$i];
        $irdsquare=$irdsquare**2;
        $irdstdsum+=$irdsquare;
    }
    $irdstdsum=$irdstdsum/($Hapinferxsum-1);
    $irdstd=sqrt($irdstdsum);
    printf CV "Mean value(STD): ";
    printf CV ("%-0.8s",$meanhid);
    printf CV "(";
    printf CV ("%-0.8s",$hidstd);
    printf CV ")       ";
    printf CV ("%-0.8s",$meanird);
    printf CV "(";
    printf CV ("%-0.8s",$irdstd);
    printf CV ")\n";
    printf CV "\n";
    for($i=0;$i<$namelength+4;$i++){
        printf CV " ";
    }
    printf CV "NLCP   NDH(Excluding the non-primary solutions)\n";
    for($k=0;$k<$Hapinferxfilenumber;$k++){
        printf CV $Hapinferxfiles[$k].":   ".$Hapinferx_low_frequency_count[$k]."      ".$Hapinferxuniquehty[$k]."\n";
    }
    $meanHapinferxlow_frequency_sum=$Hapinferx_low_frequency_sum/$Hapinferxfilenumber;
    $meanHapinferxunihaplotypesum=$Hapinferxunihaplotypesum/$Hapinferxfilenumber;
    printf CV "mean value:   ".$meanHapinferxlow_frequency_sum."   ".$meanHapinferxunihaplotypesum."\n";
    if($abnomalsolutionnumber>0){
        printf CV "Note that these iterations of HAPINFERX are not considered because their solutions contain unresolved genotypes and/or genotypes resolved by one mutation:";
        for($k=0;$k<$abnomalsolutionnumber;$k++){
            printf CV "$abnomalsolution[$k] ";
        }
        printf CV "\n";
    }
    printf CV "####################################################################\n";
    #choose the HAPINFERX's iterations with the smallest values of NDH;
    $NDHminfilesnumber=0;
    for($k=0;$k<$Hapinferxfilenumber;$k++){
        $NDHminadd2=$NDHmin+2;
        if($Hapinferxuniquehty[$k] < $NDHminadd2){
            $NDHminHapinferxfiles[$NDHminfilesnumber]=$Hapinferxfiles[$k];
            $NDHminfilesnumber++;
        }
    }
    if($NDHminfilesnumber < 10){
        for($k=0;$k<$Hapinferxfilenumber;$k++){
            if($Hapinferxuniquehty[$k] eq $NDHminadd2){
                $NDHminHapinferxfiles[$NDHminfilesnumber]=$Hapinferxfiles[$k];
                $NDHminfilesnumber++;
            }
        }
    }
    #produce an ensemble of HAPINFERX's iterations with the smallest values of NDH;
    for($k=0;$k<$NDHminfilesnumber;$k++){
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$NDHminHapinferxfiles[$k]");
        @Hapinferx=<HAPINFERXQ>;
        %Hapinferx_individual_haplotype1=();
        %Hapinferx_individual_haplotype2=();
        @Hapinferx_haplotype=();
        $haplotype_count=0;
        $sample_count=0;
        $skip_line=0;
        $t=0;
        $judge=0;
        $individual=0;
        $length=length($Hapinferx[1]);
        @Hapinferx=();
        close HAPINFERXQ;
        @second_solution_frequency=();
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$NDHminHapinferxfiles[$k]");
        while(<HAPINFERXQ>){
            $temp=$_;
            if($temp=~/TITLE: Hapinfer output data/){
                $skip_line++;
            }
            elsif($temp=~/[0-9]\s:\s[A-Z]/i && $skip_line!=0){
                $temp=~s/\W+//g;
                $temp=~s/\d+//g;
                $Hapinferx_haplotype[$haplotype_count]=$temp;
                $Hapinferx_haplotype[$haplotype_count]=~s/\s//g;
                $haplotype_count++;
            }
            elsif($temp=~/number of phenotypes/){
                $judge=1;
            }
            elsif($temp=~/#/ && $judge!=0){
                $name=();
                $name=$temp;
                $name=~s/\W+//g;
                $individual=1;
                $trans=$sample_count;
                @Hapinferx_frequency_compare=();
                $solution_count=0;
            }
            elsif($temp=~/-\s[0-9]*\s1.000000/ && $individual!=0){
                $temp=~s/\D+//g;
                $length=length($temp);
                $templength1=$length-7;
                $haplotype1=substr($temp,0,$templength1);
                $haplotype1--;
                $Hapinferx_individual_haplotype1{$name}=$Hapinferx_haplotype[$haplotype1];
                $Hapinferx_individual_haplotype1{$name}=~tr/acgt/ACGT/;
                $haplot1{$name}=$haplot1{$name}."-".$Hapinferx_individual_haplotype1{$name};
                $t=1;
            }
            elsif($temp=~/-\s[0-9]*/ && $t!=0){
                $temp=~s/\D+//g;
                $haplotype2=$temp;
                $haplotype2--;
                $Hapinferx_individual_haplotype2{$name}=$Hapinferx_haplotype[$haplotype2];
                $Hapinferx_individual_haplotype2{$name}=~tr/acgt/ACGT/;
                $haplot2{$name}=$haplot2{$name}."-".$Hapinferx_individual_haplotype2{$name};
                $t=0;
                $sample_count++;
            }
            elsif($temp=~/-\s[0-9]*\s0./){
                $position=index($temp,".");
                $position--;
                $Hapinferx_frequency_compare[$solution_count]=substr($temp,$position,8);
                @Hapinferx_frequency_compare=reverse sort(@Hapinferx_frequency_compare);
                $second_solution_frequency[$trans]=$Hapinferx_frequency_compare[0];
                $second_solution_frequency[$name]=$Hapinferx_frequency_compare[0];
                $lowfreq{$name}=$lowfreq{$name}."-".$second_solution_frequency[$name];
                $solution_count++;
            }
        }
        close HAPINFERXQ;
    }
        $hapinferxCVcompare="hapinfCV.txt";
        $hapinferxCVcompare1="hapinfCVtable.txt";
        open (HAPINFERXCV, ">$hapinferxCVcompare");
        open (TABLE,">$hapinferxCVcompare1");
        open(HAPINFERXQ,"$homedirectory/softwareresults/hapinferx/$NDHminHapinferxfiles[0]");
        $HAPINFERXjudge=0;
        $sample_count=1;
        printf TABLE "\nThe information of probability is as follows(order- ";
        for($i=0;$i<$NDHminfilesnumber;$i++){
            printf TABLE "$NDHminHapinferxfiles[$i] ";
        }
        printf TABLE "):\n";
        printf TABLE ("%-9s","Number");
        printf TABLE ("%-15s","Sample");
        printf TABLE ("%-24s","Probabilities");
        printf TABLE ("%-19s","Solution_count");
        printf TABLE ("%-40s","Solutions of individual");
        printf TABLE ("%-15s\n","Frequencies");
        while(<HAPINFERXQ>){
            $temp=$_;
            if($temp=~/number of phenotypes/){
                $HAPINFERXjudge=1;
            }
            elsif($temp=~/#/ && $HAPINFERXjudge!=0){
                $name=();
                $name=$temp;
                $name=~s/\W+//g;
                @Hapinferxcomptype1=();
                @Hapinferxcomptype2=();
                @Hapinferxlowfreq=();
                printf HAPINFERXCV "#"."$name\n";
                @Hapinferxcomptype1=split(/-/,$haplot1{$name});
                @Hapinferxcomptype2=split(/-/,$haplot2{$name});
                @Hapinferxlowfreq=split(/-/,$lowfreq{$name});
                $Hapinferxsolution=&solution_count(@Hapinferxcomptype1,@Hapinferxcomptype2);
                if($Hapinferxsolution=~/Homozygote/){
                    printf HAPINFERXCV $Hapinferxcomptype1[1]." 1.0\n";
                    printf HAPINFERXCV "$Hapinferxcomptype2[1]\n";
                }
                elsif($Hapinferxsolution==1){
                    printf HAPINFERXCV $Hapinferxcomptype1[1]." 1.0\n";
                    printf HAPINFERXCV "$Hapinferxcomptype2[1]\n";
                }
                elsif($Hapinferxsolution>1){
                    printf TABLE ("\n%-9d",$sample_count);
                    printf TABLE ("%-15s",$name);
                    for($u=1;$u<=$NDHminfilesnumber;$u++){
                        if($Hapinferxlowfreq[$u]>0.05){
                            printf TABLE "- ";}
                        elsif($Hapinferxlowfreq[$u]<=0.05){
                            printf TABLE "+ ";}
                    }
                    printf TABLE "    ".$Hapinferxsolution." solutions   ";
                    $Hapinferxsolution_returnhaplotype=&solution_haplotype($haplot1{$name},$haplot2{$name},$NDHminfilesnumber,$Hapinferxsolution);
                    @Hapinferxsolution_haplotype=split(/-/,$Hapinferxsolution_returnhaplotype);
                    @Hapinferxsolution_haplotype=reverse sort(@Hapinferxsolution_haplotype);
                    for($t=0;$t<$Hapinferxsolution;$t++){
                        $ratio_count[$t]=0;
                        printf TABLE "(";
                        for($q=0;$q<=$NDHminfilesnumber;$q++){
                            if(($Hapinferxsolution_haplotype[$t] eq $Hapinferxcomptype1[$q]) || ($Hapinferxsolution_haplotype[$t] eq $Hapinferxcomptype2[$q])){
                                printf TABLE "$NDHminHapinferxfiles[$q-1]"." ";
                                $Hapinferxsolution_haplotype1[$t]=$Hapinferxcomptype1[$q];
                                $Hapinferxsolution_haplotype2[$t]=$Hapinferxcomptype2[$q];
                                $ratio_count[$t]++;
                            }
                        }
                        printf TABLE ") ";
                    }
                    printf TABLE "(";
                    $max=0;
                    $maxnumber=0;
                    for($t=0;$t<$Hapinferxsolution;$t++){
                        printf TABLE "$ratio_count[$t] ";
                        if($ratio_count[$t]>$max){
                            $max=$ratio_count[$t];
                            $maxnumber=$t;
                        }
                    }
                    printf TABLE ") ";
                    $max/=$NDHminfilesnumber;
                    printf HAPINFERXCV $Hapinferxsolution_haplotype1[$maxnumber]." ";
                    printf HAPINFERXCV ("%-7s\n",$max);
                    printf HAPINFERXCV "$Hapinferxsolution_haplotype2[$maxnumber]\n";
                }
                $sample_count++;
            }
        }
            print "The consistency test of HAPINFERX has been finished.\n";
    }


exit;


sub solution_count{
    my(@haplotype)=@_;
    $solution_count=("Homozygote");
    %temp=();
    foreach (@haplotype){
        if($_=~/\w/){
        $temp{$_}=1;}
    }
    @uniquehaplotype=keys %temp;
    $count=(@uniquehaplotype);
    if($count==1){
        return $solution_count;
    }else{
        $solution_count=$count/2;
        return $solution_count;
    }
}

sub solution_haplotype{
    my($hty1,$hty2,$algnumber,$solucount)=@_;
    @htyp1=split(/-/,$hty1);
    @htyp2=split(/-/,$hty2);
    $returnhaplotype=();
    for($w=0;$w<$solucount;$w++){
        for($r=0;$r<=$algnumber;$r++){
            if($htyp1[$r]=~/\w/){
                $unihaplo[$w]=$htyp1[$r];
                $returnhaplotype="$returnhaplotype"."-"."$unihaplo[$w]";
                $htyp1[$r]=();
                $htyp2[$r]=();
                last;
            }
        }
        for($r=0;$r<=$algnumber;$r++){
            if(($unihaplo[$w] eq $htyp1[$r]) || ($unihaplo[$w] eq $htyp2[$r])){
                $htyp1[$r]=();
                $htyp2[$r]=();
            }
        }

    }
    return $returnhaplotype;
}

sub haplotype_count{
    my(@haplotype)=@_;
    %temp=();
    foreach (@haplotype){
        $temp{$_}=1;
    }
    @uniquehaplotype=keys %temp;
    return @uniquehaplotype;
}


sub tri_transHAPLOTYPER{
    my($first,$second,$third,$string,$m,$n,$file)=@_;
        if($third=~/\s/){
            $length=length($string);
            $stringa=substr($string,0,$m+1);
            $stringb=substr($string,$m+1,$length-$m-1);
            $stringa=~s/0/$first/;
            $stringa=~s/1/$second/;
            $trans=$stringa.$stringb;
            return $trans;
        }
        elsif($third=~/\S/){
            $length=length($string);
            $stringa=substr($string,0,$m+2);
            $stringb=substr($string,$m+2,$length-$m-2);
            $stringa=~s/00/$first/;
            $stringa=~s/01/$second/;
            $stringa=~s/10/$third/;
            $m++;
            $n++;
            if($stringa=~/11/){
                printf CV "#################################################################################################################################################################################\n";
                printf CV "###########################################################Note: There is a Swith coding error in $m site of $n individual in $file from HAPLOTYPER######################################################\n";
                printf CV "#################################################################################################################################################################################\n";
                }
            $trans=$stringa.$stringb;
            return $trans;
        }
    }

sub tri_transHAPLOTYPER2{
    my($first,$second,$third,$string,$m,$n)=@_;
        if($third=~/\s/){
            $length=length($string);
            $stringa=substr($string,0,$m+1);
            $stringb=substr($string,$m+1,$length-$m-1);
            $stringa=~s/0/$first/;
            $stringa=~s/1/$second/;
            $trans=$stringa.$stringb;
            return $trans;
        }
        elsif($third=~/\S/){
            $length=length($string);
            $stringa=substr($string,0,$m+2);
            $stringb=substr($string,$m+2,$length-$m-2);
            $stringa=~s/00/$first/;
            $stringa=~s/01/$second/;
            $stringa=~s/10/$third/;
            $m++;
            $n++;
            $trans=$stringa.$stringb;
            return $trans;
        }
    }





