$infile=$ARGV[0];
if(!$infile){
    print "Please type the name of the genotype data file in the command line!!!";
    exit;
}
open (IN, $infile);
@genotypedata=<IN>;
close IN;
$linegenotypedata=(@genotypedata);
if(!$linegenotypedata){
    print "Cannot find the genotype data file!!!\n";
    print "\nPlease type the correct name of the genotype data file in the command line or confirm that the genotype data file and the script trans.pl are located in the same folder!!!";
    exit;
}
print "  \n**********CVhaplot2.0**********\n";
print     "*    Coded by Zu-Shi Huang    *\n";
print     "*    Institute of Zoology     *\n";
print     "* Chinese Academy of Sciences *\n";
print     "*     huangzs\@ioz.ac.cn       *\n";
print     "*******************************\n";

$number_hapinferx=$ARGV[1];
if(!$number_hapinferx){
    $number_hapinferx=100;
}
$number_hapinferx++;
$haplorecnumber=$ARGV[2];
if(!$haplorecnumber){
    $haplorecnumber=10;
}
$haplorecnumber+=2;
$phasenumber=$ARGV[3];
if(!$phasenumber){
    $phasenumber=10;
}
$phasenumber++;
$haplotypernumber=$ARGV[4];
if(!$haplotypernumber){
    $haplotypernumber=10;
}
$haplotypernumber++;
$arlequinemnumber=$ARGV[5];
if(!$arlequinemnumber){
    $arlequinemnumber=10;
}
$arlequinemnumber++;

use Cwd;
$homedirectory=cwd;
mkdir "transfile", 0775;
chdir "transfile" or die "cannot chdir to transfile:$!";
mkdir "HAPINFERX", 0775;

#convert genotype data to input file of HAPINFERX and generate a file to display data's polymorphisms;
$outfile="hapinferx_input_all_sites.txt";
$characterfile="character.txt";
open (OUT, ">$outfile");
open (CHARACTER, ">$characterfile");

$lineinput=0;
$samplenumber=0;
@geno=();
@genotypesequence=();
$i=0;
$sequencelength=0;
open (IN, "$homedirectory/$infile");
while(<IN>){
    if($lineinput!=1){
        /^\s*(\S*)\s*\S*\s*$/;
        $samplenumberfrominput=$1;
        /^\s*\S*\s*(\S*)\s*$/;
        $sequencelengthfrominput=$1; 
        $lineinput++;
    }else {
        /^\s*(\S*\s*\S*)\s*$/;
        $string=$1;
        $length=length($string);
        $length=$length-10;
        if($length>$sequencelength){
                $sequencelength=$length;
        }
        $geno[$samplenumber]=substr($string,0,10);
        printf OUT "#"."$geno[$samplenumber]\n";
        $homo1 = substr($string,10,$sequencelength);
        $homo1 =~ tr/acgt/ACGT/;
        $homo1 =~ tr/sywmkr/SYWMKR/;
        $genotypesequence[$i]=$homo1;
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        printf OUT "$homo1\n";
        printf CHARACTER "$homo1\n";
        $homo2 = substr($string,10,$sequencelength);
        $homo2 =~ tr/acgt/ACGT/;
        $homo2 =~ tr/sywmkr/SYWMKR/;
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        printf OUT "$homo2\n";
        printf CHARACTER "$homo2\n";
        $samplenumber++;
        $i++;
    }
}
close IN;
if(($sequencelengthfrominput == $sequencelength) && ($samplenumberfrominput == $samplenumber)){
        print "\nThe input file may be correct.\n";
}else{
        print "The input file may be incorrect, please inspect it!\n";
        open(CHARACTER,">$characterfile");
        printf CHARACTER "incorrect input file";
        open(OUT,">$outfile");
        printf OUT "incorrect input file";
        close CHARACTER;
        close OUT;
        exit;
}

close CHARACTER;
close OUT;

$CHA="character.txt";
open(CHARACTER,$CHA);
my(%sequence);
$number=0;
while(<CHARACTER>){
    /^\s*(\S*)\s*$/;
    $sequence{$number}=$1;
    $number++;
}
close CHARACTER;

$i=0;
$judge=0;
$biallelicnumber=0;
open(CHARACTER,">$characterfile");
while($i<$sequencelength){
    if($i>0){
        printf CHARACTER "\n";
    }
    $count_of_A=0;
    $count_of_C=0;
    $count_of_G=0;
    $count_of_T=0;
    foreach $current_sequence(values(%sequence)){
        $Base=substr($current_sequence,$i,1);
        if($Base eq 'A'){
            $count_of_A++;
        }elsif($Base eq 'C'){
            $count_of_C++;
        }elsif($Base eq 'G'){
            $count_of_G++;
        }elsif($Base eq 'T'){
            $count_of_T++;
        }
    }
    $i++;
    printf CHARACTER "$i ";
    $j=0;
    $countorder=();
    %count=(A,"$count_of_A",C,"$count_of_C",G,"$count_of_G",T,"$count_of_T");
    %reversecount=reverse %count;
    foreach $countorder(values(%count)){
        if($countorder>$j){
                $j=$countorder;
                $nucleotide=$reversecount{$j};
        }
    }
    printf CHARACTER "$nucleotide";
    printf CHARACTER "(";
    printf CHARACTER ("%-0.3f",$j/(2*$samplenumber));
    printf CHARACTER ") ";
    next if($j==(2*$samplenumber));
    delete $count{$nucleotide};
    $biallelicnumber++;
    $ja=$j;
    $j=0;
    $nucleotide=();
    $countorder=();
    %reversecount=();
    %reversecount=reverse %count;
    foreach $countorder(values(%count)){
        if($countorder>$j){
                $j=$countorder;
                $nucleotide=$reversecount{$j};
        }
    }
    printf CHARACTER "$nucleotide";
    printf CHARACTER "(";
    printf CHARACTER ("%-0.3f",$j/(2*$samplenumber));
    printf CHARACTER ") ";
    next if(($ja+$j)==(2*$samplenumber));
    $biallelicnumber++;
    delete $count{$nucleotide};
    $jb=$j;
    $j=0;
    $nucleotide=();
    $countorder=();
    %reversecount=();
    %reversecount=reverse %count;
    foreach $countorder(values(%count)){
        if($countorder>$j){
                $j=$countorder;
                $nucleotide=$reversecount{$j};
        }
    }
    printf CHARACTER "$nucleotide";
    printf CHARACTER "(";
    printf CHARACTER ("%-0.3f",$j/(2*$samplenumber));
    printf CHARACTER ") ";
    if(($ja+$jb+$j)<(2*$samplenumber)){
        $judge++;
        delete $count{$nucleotide};
        @ja=values(%count);
        @nucleotidea=keys(%count);
        printf CHARACTER "$nucleotidea[0]";
        printf CHARACTER "(";
        printf CHARACTER ("%-0.3f",$ja[0]/(2*$samplenumber));
        printf CHARACTER ") ";
        printf CHARACTER "!!!!!";
        print "\nSite $i is an abnormal site which has four states, please inspect your data!\n";
    }
}
close CHARACTER;


$readfile="character.txt";
open(CHARACTER,$readfile);
$i=0;
$j=0;
@variablenumber=();
@variablesite=();
$phasevariblenumber=();
$phasesitecharacter=();
$variblesitenumber=0;
while(<CHARACTER>){
        $site=$_;
        $site=~s/\W+//g;
        $site=~s/\d+//g;
        $nucleotednumber=length($site);
        if($nucleotednumber==1){
                $variablenumber[$i]=-1;
                $i++;
        }elsif($nucleotednumber>1){
                $variablenumber[$i]=$i;
                $variablesite[$j]=$site;
                $phasesitecharacter=($nucleotednumber==2)?("$phasesitecharacter"."S"):("$phasesitecharacter"."M");
                $i++;
                $j++;
                $variblesitenumber++;
                $phasevariblenumber="$phasevariblenumber"." $i";
        }
}
close CHARACTER;

$Hapinferx="HAPINFERX/hapinferx_input_variable_sites1.txt";
open (OUT, ">$Hapinferx");
@variblesitesequence=();
$i=0;
foreach $currentsequence(@genotypesequence){
        printf OUT "#"."$geno[$i]\n";
        $nucleotide=();
        foreach $sitenumber(@variablenumber){
                if($sitenumber>=0){
                $nucleotideunit = substr($currentsequence,$sitenumber,1);
                $nucleotide="$nucleotide"."$nucleotideunit";
                }
        }
        $variblesitesequence[$i]=$nucleotide;
        $homo1 = $nucleotide;
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        printf OUT "$homo1\n";
        $homo2= $nucleotide;
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        printf OUT "$homo2\n";
        $i++;
    }
printf OUT "\n";
close OUT;

#convert input files of HAPINFERX with random orders;
@randomnumber=();
for($i=0;$i<$samplenumber;$i++){
    $randomnumber[$i]=$i;
}
for($m=2;$m<$number_hapinferx;$m++){
    $outfile="HAPINFERX/hapinferx_input_variable_sites$m.txt";
    open (OUT, ">$outfile");
    for($i=0;$i<$samplenumber;$i++){
        $j=int(rand($samplenumber));
        @randomnumber[$j,$i]=@randomnumber[$i,$j];
    }
    for($i=0;$i<$samplenumber;$i++){
        $int=$randomnumber[$i];
        printf OUT "#"."$geno[$int]\n";
        $homo1 = $variblesitesequence[$int];
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        printf OUT "$homo1\n";
        $homo2=  $variblesitesequence[$int];
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        printf OUT "$homo2\n";
    }
}

#convert genotype data to input file of PHASE;
$PHASEFile="phaseinput";
open (PHASE, ">$PHASEFile");
printf PHASE "$samplenumber\n";
printf PHASE "$variblesitenumber\n";
printf PHASE "P"."$phasevariblenumber\n";
printf PHASE "$phasesitecharacter\n";
$i=0;
foreach $currentsequence(@variblesitesequence){
        printf PHASE "#"."$geno[$i]\n";
        $homo1 = $currentsequence;
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        $homo1 =~ s/A/1 /g;
        $homo1 =~ s/C/2 /g;
        $homo1 =~ s/G/3 /g;
        $homo1 =~ s/T/4 /g;
        printf PHASE "$homo1\n";
        $homo2= $currentsequence;
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        $homo2 =~ s/A/1 /g;
        $homo2 =~ s/C/2 /g;
        $homo2 =~ s/G/3 /g;
        $homo2 =~ s/T/4 /g;
        printf PHASE "$homo2\n";
        $i++;
    }
close PHASE;

#convert genotype data to input file of Arlequin;
for($j=1;$j<$arlequinemnumber;$j++){
$ArlequinEMfile="Arlequininput$j.arp";
open (OUT, ">$ArlequinEMfile");
printf OUT "[Profile]\n";
printf OUT "         "."Title=\"Hello\""."\n";
printf OUT "         "."NbSamples=1"."\n";
printf OUT "         "."GenotypicData=1"."\n";
printf OUT "         "."DataType=DNA"."\n";
printf OUT "         "."Gameticphase=0"."\n";
printf OUT "         "."LocusSeparator=NONE"."\n";
printf OUT "\n";
printf OUT "[Data]\n";
printf OUT "[[Samples]]\n";
printf OUT "         "."SampleName=\"World\""."\n";
printf OUT "         "."SampleSize=$samplenumber\n";
printf OUT "         "."SampleData= {\n";
$i=0;
foreach $currentsequence(@variblesitesequence){
        printf OUT ("%-0.10s", $geno[$i]);
        printf OUT "1"." ";
        $homo1 = $currentsequence;
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        printf OUT "$homo1\n";
        $homo2= $currentsequence;
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        printf OUT "            "."$homo2\n";
        $i++;
    }
printf OUT "}\n";
close OUT;
}

#convert genotype data to input file of HAPLOREC;
$HaploRec="HaploRecinput";
open (OUT, ">$HaploRec");
printf OUT "Id"."$phasevariblenumber\n";
$i=0;
foreach $currentsequence(@variblesitesequence){
        $geno[$i]=~s/\s//g;
        printf OUT "$geno[$i]"." ";
        $homo1 = $currentsequence;
        $homo1 =~ tr/SYWMKR/CCAAGA/;
        $homo1 =~ s/A/1 /g;
        $homo1 =~ s/C/2 /g;
        $homo1 =~ s/G/3 /g;
        $homo1 =~ s/T/4 /g;
        printf OUT "$homo1\n";
        printf OUT "$geno[$i]"." ";
        $homo2= $currentsequence;
        $homo2 =~ tr/SYWMKR/GTTCTG/;
        $homo2 =~ s/A/1 /g;
        $homo2 =~ s/C/2 /g;
        $homo2 =~ s/G/3 /g;
        $homo2 =~ s/T/4 /g;
        printf OUT "$homo2\n";
        $i++;
    }
close OUT;

if($judge>0){
        print "\nSorry, I cann't analyze the data using HAPLOTYPER, GCHap and Gerbil due to above $judge abnormal site(s). ";
        print "However, I can still analyze the data using PHASE, Arlequin-EM, HaploRec and HAPINFERX!\n";
        print "\nIn order to use the coding switch technique with GCHap, HAPLOTYPER, and GERBIL, please consider to exclude those samples(sequences) that bear the least frequent state!\n";
        exit;
}

#convert genotype data to input file of HAPLOTYPER;
if($judge==0){
        $HAPLOTYPER="HAPLOTYPERinput";
        open (OUT, ">$HAPLOTYPER");
            foreach $currentsequence(@variblesitesequence){
                for($i=0;$i<$variblesitenumber;$i++){
                    $base=substr($currentsequence,$i,1);
                    $basenumber=length($variablesite[$i]);
                    if($basenumber==2){
                        $first_base=substr($variablesite[$i],0,1);
                        $second_base=substr($variablesite[$i],1,1);
                        $base=~s/$first_base/1/;
                        $base=~s/$second_base/2/;
                        $base=~tr/SYWMKR/000000/;
                        printf OUT $base;
                     }elsif($basenumber==3){
                        $first_base=substr($variablesite[$i],0,1);
                        $second_base=substr($variablesite[$i],1,1);
                        $third_base=substr($variablesite[$i],2,1);
                        $trans_letter=&trans_first($base,$first_base,$second_base,$third_base);
                        printf OUT $trans_letter;
                     }
                }
            printf OUT "\n";
    
            }
        close OUT;
}


#convert genotype data to input files of GCHAP;
if($judge==0){
        $GCHap="GCHapinput.ped";
        $GCHappar="GCHapinput.par";
        open (OUT, ">$GCHap");
        open (GCHPAR, ">$GCHappar");
        $j=1;
        foreach $currentsequence(@variblesitesequence){
                printf OUT "1 "."$j "."0"." "."0"." "."0"." "."0"." "."0"."  "."1  1   "; 
                        for($i=0;$i<$variblesitenumber;$i++){
                                $base=substr($currentsequence,$i,1);
                                $basenumber=length($variablesite[$i]);
                                if($basenumber==2){
                                        $first_base=substr($variablesite[$i],0,1);
                                        $second_base=substr($variablesite[$i],1,1);
                                        $base=~s/$first_base/1 1 /;
                                        $base=~s/$second_base/2 2 /;
                                        $base=~s/S/1 2 /;
                                        $base=~s/Y/1 2 /;
                                        $base=~s/M/1 2 /;
                                        $base=~s/K/1 2 /;
                                        $base=~s/W/1 2 /;
                                        $base=~s/R/1 2 /;
                                        printf OUT "$base ";
                                }elsif($basenumber==3){
                                        $first_base=substr($variablesite[$i],0,1);
                                        $second_base=substr($variablesite[$i],1,1);
                                        $third_base=substr($variablesite[$i],2,1);
                                        $trans_letter=&trans_first1($base,$first_base,$second_base,$third_base);
                                        printf OUT $trans_letter;
                                }
                        }
                        printf OUT "\n";
                        $j++;
        }
        close OUT;
        printf GCHPAR "$biallelicnumber"." 0 0 5 << n loci, risk locus, sexlinked, program code.\n";
        printf GCHPAR "0 0.0 0.0 0 << mutation locus, mutation rates male, female, haplotype something\n";
        for($i=0;$i<$biallelicnumber;$i++){
                $j=0;
                $j=$i+1;
                printf GCHPAR "$j ";
        }
        printf GCHPAR "<< Marker Order\n";
        for($i=0;$i<$biallelicnumber;$i++){
                $j=0;
                $j=$i+1;
                printf GCHPAR "3 2 SNP$j\n";
                printf GCHPAR ".5 0.5\n";
        }
        printf GCHPAR "0 0 << sexdifference, interference\n";
        for($i=1;$i<$biallelicnumber;$i++){
                printf GCHPAR "0.1 ";
        }
        printf GCHPAR "<< Spurious genetic distances.\n";
        printf GCHPAR "1 5 0.2 0.1 << Who knows what this is.\n";
        close GCHPAR;
}

#convert genotype data to input file of GERBIL;
if($judge==0){
        $Gerbil="Gerbilinput";
        open (OUT, ">$Gerbil");
        foreach $currentsequence(@variblesitesequence){
                $transble=();
                for($i=0;$i<$variblesitenumber;$i++){
                        $base=substr($currentsequence,$i,1);
                        $basenumber=length($variablesite[$i]);
                        if($basenumber==2){
                                $first_base=substr($variablesite[$i],0,1);
                                $second_base=substr($variablesite[$i],1,1);
                                $base=~s/$first_base/0        /;
                                $base=~s/$second_base/1        /;
                                $base=~s/S/2        /;
                                $base=~s/Y/2        /;
                                $base=~s/M/2        /;
                                $base=~s/K/2        /;
                                $base=~s/W/2        /;
                                $base=~s/R/2        /;
                                printf OUT "$base";
                                $transble="$transble"."$base";
                        }elsif($basenumber==3){
                                $first_base=substr($variablesite[$i],0,1);
                                $second_base=substr($variablesite[$i],1,1);
                                $third_base=substr($variablesite[$i],2,1);
                                $trans_letter=&trans_first2($base,$first_base,$second_base,$third_base);
                                printf OUT $trans_letter;
                                $transble="$transble"."$trans_letter";
                        }
                }
        printf OUT "\n";
        printf OUT "$transble\n";
        }
        close OUT;
        print "\nCongratulations! I have finished the file conversion!\n\n";
        print "********************************************************\n";
        print "\nNow you can launch HAPINFERX,GERBIL,GCHAP,HAPLOREC by double-clicking on the file batchsoftwarewin.bat or typing its name in the command line in Windows!\n";
        print "\nYou can also launch PHASE and HAPLOTYPER by typing the name of batchsoftwarelinux in the command line in Windows!\n";
        print "\nThe batch file batchArlequinEM.arb allows multiple independent iterations of Arlequin-EM to be performed in Windows!\n";
        print "\n********************************************************\n";
}

chdir $homedirectory or die "cannot chdir to $homedirectory:$!";
mkdir "softwareresults", 0775;
chdir "softwareresults" or die "cannot chdir to softwareresults:$!";
mkdir "hapinferx", 0775;
mkdir "gchap", 0775;
mkdir "gerbil", 0775;
mkdir "phase", 0775;
mkdir "haplotyper", 0775;
mkdir "arlequin", 0775;
mkdir "haplorec", 0775;

chdir $homedirectory or die "cannot chdir to $homedirectory:$!";
$batch="batchsoftware.txt";
$batch1="batchsoftwarelinux";
$batcharleem="batchArlequinEM.arb";
open (BATCH, ">$batch");
open (BATCHLINUX, ">$batch1");
open (BATCHARLEQUIN, ">$batcharleem");
printf BATCH "gerbil.exe "."transfile/Gerbilinput "."softwareresults/gerbil/gerbiloutput\n";
printf BATCH "Java ApproxGCHap "."transfile/GCHapinput.par "."transfile/GCHapinput.ped >gchapoutput\n";
printf BATCH "move "."gchapoutput "."softwareresults/gchap\n";
for($i=2;$i<$haplorecnumber;$i++){
    printf BATCH "Java -Xmx1024m -jar HaploRec.jar -od -s -cp -p S -n $i "."transfile/HaploRecinput\n";
    printf BATCH "move "."HaploRecinput.reconstructed "."softwareresults/haplorec/HaploRecinput$i.reconstructed\n";
}
for($i=1;$i<$number_hapinferx;$i++){
    printf BATCH "hap.pl "."transfile/HAPINFERX/hapinferx_input_variable_sites$i.txt "."softwareresults/hapinferx/hapinferxout$i\n";
}
close BATCH;
open (CHANGE, $batch);
@batchcommand=<CHANGE>;
close CHANGE;
open (BATCH, ">$batch");
$linebachcommond=@batchcommand;
for($i=0;$i<$linebachcommond;$i++){
    $temp=$batchcommand[$i];
    $temp=~tr/\//\\/;
    printf BATCH "$temp";
}
close BATCH;
for($i=1;$i<$phasenumber;$i++){
    $j=int(rand(100000));
    printf BATCHLINUX "./PHASE -S$j phaseinput $i"."phaseout 100 1 100\n";
}
for($i=1;$i<$haplotypernumber;$i++){
    printf BATCHLINUX "./htyperv2 HAPLOTYPERinput haplotyperout$i $biallelicnumber $samplenumber 20\n";
}
rename "batchsoftware.txt", "batchsoftwarewin.bat";
for($i=1;$i<$arlequinemnumber;$i++){
    printf BATCHARLEQUIN "Arlequininput$i.arp\n";
}
close BATCHARLEQUIN;
exit;


sub trans_first{
    my($Letter_number,$first,$second,$three)=@_;
    if($Letter_number eq $first){
        $Letter_number=(11);
        return $Letter_number;
    }elsif($Letter_number eq $second){
        $Letter_number=(12);
        return $Letter_number;
    }elsif($Letter_number eq $three){
        $Letter_number=(21);
        return $Letter_number;
    }else{
        $Letter_number=&trans_second($Letter_number,$first,$second,$three);
        return $Letter_number;
    }
}

sub trans_second{
    my($Letter_number,$first,$second,$three)=@_;
    $Letter_number=~s/S/CG/;
    $Letter_number=~s/Y/CT/;
    $Letter_number=~s/K/GT/;
    $Letter_number=~s/M/AC/;
    $Letter_number=~s/W/AT/;
    $Letter_number=~s/R/AG/;
    @comparea=($first,$second);
    @comparea=sort(@comparea);
    $comparea=$comparea[0].$comparea[1];

    @compareb=($first,$three);
    @compareb=sort(@compareb);
    $compareb=$compareb[0].$compareb[1];

    @comparec=($second,$three);
    @comparec=sort(@comparec);
    $comparec=$comparec[0].$comparec[1];

    if($Letter_number eq $comparea){
        $Letter_number=(10);
        return $Letter_number;
    }elsif($Letter_number eq $compareb){
        $Letter_number=("0"."1");
        return $Letter_number;
    }elsif($Letter_number eq $comparec){
        $Letter_number=("0"."0");
        return $Letter_number;
    }
}

sub trans_first1{
    my($Letter_number,$first,$second,$three)=@_;
    if($Letter_number eq $first){
        $Letter_number=("1 1  1 1  ");
        return $Letter_number;
    }elsif($Letter_number eq $second){
        $Letter_number=("1 1  2 2  ");
        return $Letter_number;
    }elsif($Letter_number eq $three){
        $Letter_number=("2 2  1 1  ");
        return $Letter_number;
    }else{
        $Letter_number=&trans_second1($Letter_number,$first,$second,$three);
        return $Letter_number;
    }
}

sub trans_second1{
    my($Letter_number,$first,$second,$three)=@_;
    $Letter_number=~s/S/CG/;
    $Letter_number=~s/Y/CT/;
    $Letter_number=~s/K/GT/;
    $Letter_number=~s/M/AC/;
    $Letter_number=~s/W/AT/;
    $Letter_number=~s/R/AG/;
    @comparea=($first,$second);
    @comparea=sort(@comparea);
    $comparea=$comparea[0].$comparea[1];

    @compareb=($first,$three);
    @compareb=sort(@compareb);
    $compareb=$compareb[0].$compareb[1];

    @comparec=($second,$three);
    @comparec=sort(@comparec);
    $comparec=$comparec[0].$comparec[1];

    if($Letter_number eq $comparea){
        $Letter_number=("1 1  1 2  ");
        return $Letter_number;
    }elsif($Letter_number eq $compareb){
        $Letter_number=("2 1  1 1  ");
        return $Letter_number;
    }elsif($Letter_number eq $comparec){
        $Letter_number=("2 1  1 2  ");
        return $Letter_number;
    }
}

sub trans_first2{
    my($Letter_number,$first,$second,$three)=@_;
    if($Letter_number eq $first){
        $Letter_number=("0        0        ");
        return $Letter_number;
    }elsif($Letter_number eq $second){
        $Letter_number=("0        1        ");
        return $Letter_number;
    }elsif($Letter_number eq $three){
        $Letter_number=("1        0        ");
        return $Letter_number;
    }else{
        $Letter_number=&trans_second2($Letter_number,$first,$second,$three);
        return $Letter_number;
    }
}

sub trans_second2{
    my($Letter_number,$first,$second,$three)=@_;
    $Letter_number=~s/S/CG/;
    $Letter_number=~s/Y/CT/;
    $Letter_number=~s/K/GT/;
    $Letter_number=~s/M/AC/;
    $Letter_number=~s/W/AT/;
    $Letter_number=~s/R/AG/;
    @comparea=($first,$second);
    @comparea=sort(@comparea);
    $comparea=$comparea[0].$comparea[1];

    @compareb=($first,$three);
    @compareb=sort(@compareb);
    $compareb=$compareb[0].$compareb[1];

    @comparec=($second,$three);
    @comparec=sort(@comparec);
    $comparec=$comparec[0].$comparec[1];

    if($Letter_number eq $comparea){
        $Letter_number=("0        2        ");
        return $Letter_number;
    }elsif($Letter_number eq $compareb){
        $Letter_number=("2        0        ");
        return $Letter_number;
    }elsif($Letter_number eq $comparec){
        $Letter_number=("2        2        ");
        return $Letter_number;
    }
}